# ImageTargetCollectionApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createImageTargetCollection**](ImageTargetCollectionApi.md#createImageTargetCollection) | **POST** /targetCollection | Create Image Target Collection
[**deleteImageTargetCollection**](ImageTargetCollectionApi.md#deleteImageTargetCollection) | **DELETE** /targetCollection/{tcId} | Delete Image Target Collection
[**generateCloudArchive**](ImageTargetCollectionApi.md#generateCloudArchive) | **POST** /targetCollection/{tcId}/generation/cloudarchive | Generate Cloud Archive
[**generateWTC**](ImageTargetCollectionApi.md#generateWTC) | **POST** /targetCollection/{tcId}/generation/wtc | Generate WTC
[**getCloudArchiveStatus**](ImageTargetCollectionApi.md#getCloudArchiveStatus) | **GET** /targetCollection/{tcId}/generation/cloudarchive/{generationId} | Status - Generate Cloud Archive
[**getImageTargetCollection**](ImageTargetCollectionApi.md#getImageTargetCollection) | **GET** /targetCollection/{tcId} | Get Image Target Collection
[**getImageTargetCollections**](ImageTargetCollectionApi.md#getImageTargetCollections) | **GET** /targetCollection | Get all Image Target Collections
[**getSimilarityCheckStatus**](ImageTargetCollectionApi.md#getSimilarityCheckStatus) | **GET** /targetCollection/{tcId}/similarity/{generationId} | Status - Similarity Check
[**getWTCStatus**](ImageTargetCollectionApi.md#getWTCStatus) | **GET** /targetCollection/{tcId}/generation/wtc/{generationId} | Status - Generate WTC
[**similarityCheck**](ImageTargetCollectionApi.md#similarityCheck) | **POST** /targetCollection/{tcId}/similarity | Similarity Check
[**updateImageTargetCollection**](ImageTargetCollectionApi.md#updateImageTargetCollection) | **POST** /targetCollection/{tcId} | Update Image Target Collection


<a name="createImageTargetCollection"></a>
# **createImageTargetCollection**
> ImageTargetCollectionResponse createImageTargetCollection(xVersion, xToken, contentType, createImageTargetCollectionBody)

Create Image Target Collection

Create a new target collection in your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    CreateImageTargetCollectionBody createImageTargetCollectionBody = new CreateImageTargetCollectionBody(); // CreateImageTargetCollectionBody | 
    try {
      ImageTargetCollectionResponse result = apiInstance.createImageTargetCollection(xVersion, xToken, contentType, createImageTargetCollectionBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#createImageTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **createImageTargetCollectionBody** | [**CreateImageTargetCollectionBody**](CreateImageTargetCollectionBody.md)|  |

### Return type

[**ImageTargetCollectionResponse**](ImageTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The newly created TargetCollection. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="deleteImageTargetCollection"></a>
# **deleteImageTargetCollection**
> deleteImageTargetCollection(xVersion, xToken, tcId)

Delete Image Target Collection

Delete a particular target collection from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    try {
      apiInstance.deleteImageTargetCollection(xVersion, xToken, tcId);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#deleteImageTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**204** | Successful operation - Empty response body. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="generateCloudArchive"></a>
# **generateCloudArchive**
> CloudArchiveGenerationResponse generateCloudArchive(xVersion, xToken, tcId)

Generate Cloud Archive

DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \&quot;deprecated\&quot; since the behaviour will slightly change. However, this endpoint will still exist in version 3. 

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    try {
      CloudArchiveGenerationResponse result = apiInstance.generateCloudArchive(xVersion, xToken, tcId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#generateCloudArchive");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |

### Return type

[**CloudArchiveGenerationResponse**](CloudArchiveGenerationResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**202** | successful execution |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | TARGET_COLLECTION_NOT_FOUND  |  -  |
**412** | TARGET_COLLECTION_IS_UP_TO_DATE&lt;br/&gt; TARGET_COLLECTION_GENERATION_PENDING&lt;br/&gt; TARGET_COLLECTION_IS_EMPTY  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="generateWTC"></a>
# **generateWTC**
> GenerateWTCStatusResponse generateWTC(xVersion, xToken, contentType, tcId, generateWTCBody)

Generate WTC

Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    GenerateWTCBody generateWTCBody = new GenerateWTCBody(); // GenerateWTCBody | 
    try {
      GenerateWTCStatusResponse result = apiInstance.generateWTC(xVersion, xToken, contentType, tcId, generateWTCBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#generateWTC");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |
 **generateWTCBody** | [**GenerateWTCBody**](GenerateWTCBody.md)|  |

### Return type

[**GenerateWTCStatusResponse**](GenerateWTCStatusResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**202** | The particular requested generation status. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | TARGET_COLLECTION_NOT_FOUND  |  -  |
**412** | TARGET_COLLECTION_IS_EMPTY&lt;br/&gt; TARGET_COLLECTION_TOO_LARGE_FOR_WTC  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getCloudArchiveStatus"></a>
# **getCloudArchiveStatus**
> CloudArchiveGenerationResponse getCloudArchiveStatus(xVersion, xToken, tcId, generationId)

Status - Generate Cloud Archive

Retrieves information status about a particular scheduled cloud archive generation.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    String generationId = "generationId_example"; // String | Unique identifier of the asynchronous job created by a generation endpoint.
    try {
      CloudArchiveGenerationResponse result = apiInstance.getCloudArchiveStatus(xVersion, xToken, tcId, generationId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#getCloudArchiveStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |
 **generationId** | **String**| Unique identifier of the asynchronous job created by a generation endpoint. |

### Return type

[**CloudArchiveGenerationResponse**](CloudArchiveGenerationResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The particular requested generation job details. In case JSON attribute status is \&quot;COMPLETED\&quot; the generation finished.  |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getImageTargetCollection"></a>
# **getImageTargetCollection**
> ImageTargetCollectionResponse getImageTargetCollection(xVersion, xToken, tcId)

Get Image Target Collection

Request a particular target collection from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    try {
      ImageTargetCollectionResponse result = apiInstance.getImageTargetCollection(xVersion, xToken, tcId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#getImageTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |

### Return type

[**ImageTargetCollectionResponse**](ImageTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The particular requested TargetCollection. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getImageTargetCollections"></a>
# **getImageTargetCollections**
> List&lt;ImageTargetCollectionResponse&gt; getImageTargetCollections(xVersion, xToken, skip, limit)

Get all Image Target Collections

Request all target collections from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    Integer skip = 56; // Integer | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
    Integer limit = 56; // Integer | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
    try {
      List<ImageTargetCollectionResponse> result = apiInstance.getImageTargetCollections(xVersion, xToken, skip, limit);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#getImageTargetCollections");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **skip** | **Integer**| Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 | [optional]
 **limit** | **Integer**| Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 | [optional]

### Return type

[**List&lt;ImageTargetCollectionResponse&gt;**](ImageTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The Array of Image Target Collections in your account. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  |  -  |
**401** | INVALID_TOKEN  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getSimilarityCheckStatus"></a>
# **getSimilarityCheckStatus**
> SimilarityCheckStatusResponse getSimilarityCheckStatus(xVersion, xToken, tcId, generationId)

Status - Similarity Check

Retrieves information status of a particular scheduled \&quot;Similarity Check\&quot;.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    String generationId = "generationId_example"; // String | Unique identifier of the asynchronous job created by a generation endpoint.
    try {
      SimilarityCheckStatusResponse result = apiInstance.getSimilarityCheckStatus(xVersion, xToken, tcId, generationId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#getSimilarityCheckStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |
 **generationId** | **String**| Unique identifier of the asynchronous job created by a generation endpoint. |

### Return type

[**SimilarityCheckStatusResponse**](SimilarityCheckStatusResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The requested job information as JSON with \&quot;id\&quot;, \&quot;status\&quot;, \&quot;inputParams\&quot;, \&quot;created\&quot; and \&quot;estimatedLatency\&quot; attributes. In case status is \&quot;FAILED\&quot; and \&quot;error\&quot; attribute is added to provide more details. Once status is \&quot;COMPLETED\&quot; a \&quot;payload\&quot; attribute holds the list of images where each of them has an additional \&quot;candidates\&quot;-attribute in case of success or an \&quot;error\&quot;-object in case an unexpected error occurred. A candidate has a \&quot;targetName\&quot; and a \&quot;score\&quot; value between 0 and 1, where a large score means a high similarity. Every job has an \&quot;input\&quot;-attribute holding the JSON-Object used for creation (same information as used in POST-body plus \&quot;tcId\&quot;). Life cycle of a job is SCHEDULED -&gt; RUNNING -&gt; COMPLETED/FAILED.  |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | GENERATION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getWTCStatus"></a>
# **getWTCStatus**
> GenerateWTCStatusResponse getWTCStatus(xVersion, xToken, tcId, generationId)

Status - Generate WTC

Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    String generationId = "generationId_example"; // String | Unique identifier of the asynchronous job created by a generation endpoint.
    try {
      GenerateWTCStatusResponse result = apiInstance.getWTCStatus(xVersion, xToken, tcId, generationId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#getWTCStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |
 **generationId** | **String**| Unique identifier of the asynchronous job created by a generation endpoint. |

### Return type

[**GenerateWTCStatusResponse**](GenerateWTCStatusResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The particular requested generation status. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | GENERATION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="similarityCheck"></a>
# **similarityCheck**
> SimilarityCheckResponse similarityCheck(xVersion, xToken, contentType, tcId, similarityCheckBody)

Similarity Check

Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \&quot;candidates\&quot; with a similarity \&quot;score\&quot; are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \&quot;maxCandidates\&quot; to define the maximum amount of candidates to return for an image. Response header value \&quot;Location\&quot; directly points to the right \&quot;Status - Similarity Check\&quot; endpoint. Best practice is to trigger \&quot;Similarity Check\&quot;, wait for \&quot;estimatedLatency\&quot; milliseconds and poll \&quot;Status - Similarity Check\&quot; endpoint every 5 seconds until its \&quot;status\&quot; is \&quot;COMPLETED\&quot;. 

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    SimilarityCheckBody similarityCheckBody = new SimilarityCheckBody(); // SimilarityCheckBody | 
    try {
      SimilarityCheckResponse result = apiInstance.similarityCheck(xVersion, xToken, contentType, tcId, similarityCheckBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#similarityCheck");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |
 **similarityCheckBody** | [**SimilarityCheckBody**](SimilarityCheckBody.md)|  |

### Return type

[**SimilarityCheckResponse**](SimilarityCheckResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**202** | Response Code with header value \&quot;Location\&quot; which points to the \&quot;Status - Similarity Check\&quot; endpoint. Body holds async job information. A JSON Object with an \&quot;id\&quot; (for \&quot;Status - Similarity Check\&quot; GET endpoint), \&quot;inputParams\&quot; (JSON Object holding the \&quot;images\&quot; as a list and the tcId), \&quot;status\&quot; (\&quot;SCHEDULED\&quot;, \&quot;COMPLETED\&quot;, \&quot;FAILED\&quot;), \&quot;estimatedLatency\&quot; and \&quot;created\&quot; timestamps.  |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  |  -  |
**401** | INVALID_TOKEN  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="updateImageTargetCollection"></a>
# **updateImageTargetCollection**
> ImageTargetCollectionResponse updateImageTargetCollection(xVersion, xToken, contentType, tcId, updateImageTargetCollectionBody)

Update Image Target Collection

Update a target collection from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ImageTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ImageTargetCollectionApi apiInstance = new ImageTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Image Target Collection.
    UpdateImageTargetCollectionBody updateImageTargetCollectionBody = new UpdateImageTargetCollectionBody(); // UpdateImageTargetCollectionBody | 
    try {
      ImageTargetCollectionResponse result = apiInstance.updateImageTargetCollection(xVersion, xToken, contentType, tcId, updateImageTargetCollectionBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ImageTargetCollectionApi#updateImageTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Image Target Collection. |
 **updateImageTargetCollectionBody** | [**UpdateImageTargetCollectionBody**](UpdateImageTargetCollectionBody.md)|  |

### Return type

[**ImageTargetCollectionResponse**](ImageTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The updated Image Target Collection. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

