# ObjectTargetApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createObjectTargetFromImages**](ObjectTargetApi.md#createObjectTargetFromImages) | **POST** /objectTargetCollection/{tcId}/target/images | Create Object Target from Images
[**createObjectTargetFromWTO**](ObjectTargetApi.md#createObjectTargetFromWTO) | **POST** /objectTargetCollection/{tcId}/target/wto | Create Object Target from WTO
[**deleteObjectTarget**](ObjectTargetApi.md#deleteObjectTarget) | **DELETE** /objectTargetCollection/{tcId}/target/{targetId} | Delete Object Target
[**extendObjectTarget**](ObjectTargetApi.md#extendObjectTarget) | **PUT** /objectTargetCollection/{tcId}/target/{targetId} | Extend Object Target
[**getObjectTarget**](ObjectTargetApi.md#getObjectTarget) | **GET** /objectTargetCollection/{tcId}/target/{targetId} | Get Object Target
[**getObjectTargetStatus**](ObjectTargetApi.md#getObjectTargetStatus) | **GET** /objectTargetCollection/{tcId}/generation/targets/{generationId} | Status - Object Target Generation Information
[**getObjectTargets**](ObjectTargetApi.md#getObjectTargets) | **GET** /objectTargetCollection/{tcId}/target | Get Object Targets
[**renameObjectTarget**](ObjectTargetApi.md#renameObjectTarget) | **PUT** /objectTargetCollection/{tcId}/target/{targetId}/name | Rename Object Target


<a name="createObjectTargetFromImages"></a>
# **createObjectTargetFromImages**
> ObjectTargetJobResponse createObjectTargetFromImages(xVersion, xToken, contentType, tcId, createObjectTargetImagesBody)

Create Object Target from Images

Create a new Object Target in an Object Target Collection from at least two Image files.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    CreateObjectTargetImagesBody createObjectTargetImagesBody = new CreateObjectTargetImagesBody(); // CreateObjectTargetImagesBody | 
    try {
      ObjectTargetJobResponse result = apiInstance.createObjectTargetFromImages(xVersion, xToken, contentType, tcId, createObjectTargetImagesBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#createObjectTargetFromImages");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **createObjectTargetImagesBody** | [**CreateObjectTargetImagesBody**](CreateObjectTargetImagesBody.md)|  |

### Return type

[**ObjectTargetJobResponse**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The asynchronous job information. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="createObjectTargetFromWTO"></a>
# **createObjectTargetFromWTO**
> ObjectTargetJobResponse createObjectTargetFromWTO(xVersion, xToken, contentType, tcId, createObjectTargetWTOBody)

Create Object Target from WTO

Create a new Object Target in an Object Target Collection from a WTO file.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    CreateObjectTargetWTOBody createObjectTargetWTOBody = new CreateObjectTargetWTOBody(); // CreateObjectTargetWTOBody | 
    try {
      ObjectTargetJobResponse result = apiInstance.createObjectTargetFromWTO(xVersion, xToken, contentType, tcId, createObjectTargetWTOBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#createObjectTargetFromWTO");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **createObjectTargetWTOBody** | [**CreateObjectTargetWTOBody**](CreateObjectTargetWTOBody.md)|  |

### Return type

[**ObjectTargetJobResponse**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The asynchronous job information. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="deleteObjectTarget"></a>
# **deleteObjectTarget**
> deleteObjectTarget(xVersion, xToken, tcId, targetId)

Delete Object Target

Delete a particular Object Target from your Object Target Collection.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    String targetId = "targetId_example"; // String | Unique identifier of the Object Target.
    try {
      apiInstance.deleteObjectTarget(xVersion, xToken, tcId, targetId);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#deleteObjectTarget");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **targetId** | **String**| Unique identifier of the Object Target. |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**204** | Successful operation - Empty response body. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="extendObjectTarget"></a>
# **extendObjectTarget**
> ObjectTargetJobResponse extendObjectTarget(xVersion, xToken, contentType, tcId, targetId, extendObjectTargetBody)

Extend Object Target

Add source images to an existing target.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    String targetId = "targetId_example"; // String | Unique identifier of the Object Target.
    ExtendObjectTargetBody extendObjectTargetBody = new ExtendObjectTargetBody(); // ExtendObjectTargetBody | 
    try {
      ObjectTargetJobResponse result = apiInstance.extendObjectTarget(xVersion, xToken, contentType, tcId, targetId, extendObjectTargetBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#extendObjectTarget");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **targetId** | **String**| Unique identifier of the Object Target. |
 **extendObjectTargetBody** | [**ExtendObjectTargetBody**](ExtendObjectTargetBody.md)|  |

### Return type

[**ObjectTargetJobResponse**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The asynchronous job information. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; TARGET_NOT_EXTENDABLE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getObjectTarget"></a>
# **getObjectTarget**
> ObjectTargetResponse getObjectTarget(xVersion, xToken, tcId, targetId)

Get Object Target

Request a specific Object Targets from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    String targetId = "targetId_example"; // String | Unique identifier of the Object Target.
    try {
      ObjectTargetResponse result = apiInstance.getObjectTarget(xVersion, xToken, tcId, targetId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#getObjectTarget");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **targetId** | **String**| Unique identifier of the Object Target. |

### Return type

[**ObjectTargetResponse**](ObjectTargetResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The requested Object Target. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getObjectTargetStatus"></a>
# **getObjectTargetStatus**
> ObjectTargetJobResponse getObjectTargetStatus(xVersion, xToken, tcId, generationId)

Status - Object Target Generation Information

Retrieves information status about a particular scheduled Object Target creation.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    String generationId = "generationId_example"; // String | Unique identifier of the asynchronous job created by a generation endpoint.
    try {
      ObjectTargetJobResponse result = apiInstance.getObjectTargetStatus(xVersion, xToken, tcId, generationId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#getObjectTargetStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **generationId** | **String**| Unique identifier of the asynchronous job created by a generation endpoint. |

### Return type

[**ObjectTargetJobResponse**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The asynchronous job information. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | GENERATION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getObjectTargets"></a>
# **getObjectTargets**
> List&lt;ObjectTargetResponse&gt; getObjectTargets(xVersion, xToken, tcId)

Get Object Targets

Request all Object Targets in a Target Collection.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    try {
      List<ObjectTargetResponse> result = apiInstance.getObjectTargets(xVersion, xToken, tcId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#getObjectTargets");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |

### Return type

[**List&lt;ObjectTargetResponse&gt;**](ObjectTargetResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Array of all Object Targets. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="renameObjectTarget"></a>
# **renameObjectTarget**
> ObjectTargetJobResponse renameObjectTarget(xVersion, xToken, contentType, tcId, targetId, renameObjectTargetBody)

Rename Object Target

Rename an existing target.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetApi apiInstance = new ObjectTargetApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    String targetId = "targetId_example"; // String | Unique identifier of the Object Target.
    RenameObjectTargetBody renameObjectTargetBody = new RenameObjectTargetBody(); // RenameObjectTargetBody | 
    try {
      ObjectTargetJobResponse result = apiInstance.renameObjectTarget(xVersion, xToken, contentType, tcId, targetId, renameObjectTargetBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetApi#renameObjectTarget");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **targetId** | **String**| Unique identifier of the Object Target. |
 **renameObjectTargetBody** | [**RenameObjectTargetBody**](RenameObjectTargetBody.md)|  |

### Return type

[**ObjectTargetJobResponse**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**202** | The asynchronous job information. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

