# ObjectTargetCollectionApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createObjectTargetCollection**](ObjectTargetCollectionApi.md#createObjectTargetCollection) | **POST** /objectTargetCollection | Create Object Target Collection
[**deleteObjectTargetCollection**](ObjectTargetCollectionApi.md#deleteObjectTargetCollection) | **DELETE** /objectTargetCollection/{tcId} | Delete Object Target Collection
[**generateWTO**](ObjectTargetCollectionApi.md#generateWTO) | **POST** /objectTargetCollection/{tcId}/generation/wto | Generate WTO
[**getObjectTargetCollection**](ObjectTargetCollectionApi.md#getObjectTargetCollection) | **GET** /objectTargetCollection/{tcId} | Get Object Target Collection
[**getObjectTargetCollectionStatus**](ObjectTargetCollectionApi.md#getObjectTargetCollectionStatus) | **GET** /objectTargetCollection/{tcId}/jobs | Status - Get Object Target Collection jobs
[**getObjectTargetCollections**](ObjectTargetCollectionApi.md#getObjectTargetCollections) | **GET** /objectTargetCollection | Get all Object Target Collections
[**getWTOStatus**](ObjectTargetCollectionApi.md#getWTOStatus) | **GET** /objectTargetCollection/{tcId}/generation/wto/{generationId} | Status - Generate WTO
[**updateObjectTargetCollection**](ObjectTargetCollectionApi.md#updateObjectTargetCollection) | **PUT** /objectTargetCollection/{tcId} | Update Object Target Collection


<a name="createObjectTargetCollection"></a>
# **createObjectTargetCollection**
> ObjectTargetCollectionResponse createObjectTargetCollection(xVersion, xToken, contentType, createObjectTargetCollectionBody)

Create Object Target Collection

Create a new Object Target Collection in your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    CreateObjectTargetCollectionBody createObjectTargetCollectionBody = new CreateObjectTargetCollectionBody(); // CreateObjectTargetCollectionBody | 
    try {
      ObjectTargetCollectionResponse result = apiInstance.createObjectTargetCollection(xVersion, xToken, contentType, createObjectTargetCollectionBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#createObjectTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **createObjectTargetCollectionBody** | [**CreateObjectTargetCollectionBody**](CreateObjectTargetCollectionBody.md)|  |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful operation |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="deleteObjectTargetCollection"></a>
# **deleteObjectTargetCollection**
> deleteObjectTargetCollection(xVersion, xToken, tcId)

Delete Object Target Collection

Delete a Object Target Collection and all its Object Targets.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    try {
      apiInstance.deleteObjectTargetCollection(xVersion, xToken, tcId);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#deleteObjectTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |

### Return type

null (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**204** | Successful operation - Empty response body. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="generateWTO"></a>
# **generateWTO**
> ObjectTargetCollectionJobResponse generateWTO(xVersion, xToken, contentType, tcId, generateWTOBody)

Generate WTO

Generate a WTO file containing the Object Target Collection and all its Object Targets.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    GenerateWTOBody generateWTOBody = new GenerateWTOBody(); // GenerateWTOBody | 
    try {
      ObjectTargetCollectionJobResponse result = apiInstance.generateWTO(xVersion, xToken, contentType, tcId, generateWTOBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#generateWTO");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **generateWTOBody** | [**GenerateWTOBody**](GenerateWTOBody.md)|  |

### Return type

[**ObjectTargetCollectionJobResponse**](ObjectTargetCollectionJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**202** | Returns job status. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**412** | OBJECT_TARGET_COLLECTION_IS_EMPTY  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getObjectTargetCollection"></a>
# **getObjectTargetCollection**
> ObjectTargetCollectionResponse getObjectTargetCollection(xVersion, xToken, tcId)

Get Object Target Collection

Request a particular Object Target Collection from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    try {
      ObjectTargetCollectionResponse result = apiInstance.getObjectTargetCollection(xVersion, xToken, tcId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#getObjectTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful operation |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getObjectTargetCollectionStatus"></a>
# **getObjectTargetCollectionStatus**
> List&lt;ObjectTargetJobResponse&gt; getObjectTargetCollectionStatus(xVersion, xToken, tcId, skip, limit, source, type)

Status - Get Object Target Collection jobs

Retrieves a list of asynchronous jobs sorted by creation date.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    Integer skip = 0; // Integer | Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0
    Integer limit = 1000; // Integer | Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10
    String source = "api"; // String | filter the jobs by source. Available values (api, studio). Default value: api
    String type = "api"; // String | filter the jobs by type.
    try {
      List<ObjectTargetJobResponse> result = apiInstance.getObjectTargetCollectionStatus(xVersion, xToken, tcId, skip, limit, source, type);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#getObjectTargetCollectionStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **skip** | **Integer**| Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 | [optional]
 **limit** | **Integer**| Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 | [optional]
 **source** | **String**| filter the jobs by source. Available values (api, studio). Default value: api | [optional]
 **type** | **String**| filter the jobs by type. | [optional]

### Return type

[**List&lt;ObjectTargetJobResponse&gt;**](ObjectTargetJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Returns a list of the asynchronous jobs. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | GENERATION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getObjectTargetCollections"></a>
# **getObjectTargetCollections**
> List&lt;ObjectTargetCollectionResponse&gt; getObjectTargetCollections(xVersion, xToken, skip, limit)

Get all Object Target Collections

Request all Object Target Collections from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    Integer skip = 56; // Integer | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
    Integer limit = 56; // Integer | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
    try {
      List<ObjectTargetCollectionResponse> result = apiInstance.getObjectTargetCollections(xVersion, xToken, skip, limit);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#getObjectTargetCollections");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **skip** | **Integer**| Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 | [optional]
 **limit** | **Integer**| Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 | [optional]

### Return type

[**List&lt;ObjectTargetCollectionResponse&gt;**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful response |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | FEATURE_NOT_SUPPORTED  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="getWTOStatus"></a>
# **getWTOStatus**
> ObjectTargetCollectionJobResponse getWTOStatus(xVersion, xToken, tcId, generationId)

Status - Generate WTO

Retrieves information status about a particular scheduled wto generation.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    String generationId = "generationId_example"; // String | Unique identifier of the asynchronous job created by a generation endpoint.
    try {
      ObjectTargetCollectionJobResponse result = apiInstance.getWTOStatus(xVersion, xToken, tcId, generationId);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#getWTOStatus");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **generationId** | **String**| Unique identifier of the asynchronous job created by a generation endpoint. |

### Return type

[**ObjectTargetCollectionJobResponse**](ObjectTargetCollectionJobResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | Returns status of the asynchronous job. |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | GENERATION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

<a name="updateObjectTargetCollection"></a>
# **updateObjectTargetCollection**
> ObjectTargetCollectionResponse updateObjectTargetCollection(xVersion, xToken, contentType, tcId, updateObjectTargetCollectionBody)

Update Object Target Collection

Updates an existing Object Target Collection in your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ObjectTargetCollectionApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ObjectTargetCollectionApi apiInstance = new ObjectTargetCollectionApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    String contentType = "contentType_example"; // String | The Content Type of the body. Must be set to application/json.
    String tcId = "tcId_example"; // String | Unique identifier of the Object Target Collection.
    UpdateObjectTargetCollectionBody updateObjectTargetCollectionBody = new UpdateObjectTargetCollectionBody(); // UpdateObjectTargetCollectionBody | 
    try {
      ObjectTargetCollectionResponse result = apiInstance.updateObjectTargetCollection(xVersion, xToken, contentType, tcId, updateObjectTargetCollectionBody);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ObjectTargetCollectionApi#updateObjectTargetCollection");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **contentType** | **String**| The Content Type of the body. Must be set to application/json. |
 **tcId** | **String**| Unique identifier of the Object Target Collection. |
 **updateObjectTargetCollectionBody** | [**UpdateObjectTargetCollectionBody**](UpdateObjectTargetCollectionBody.md)|  |

### Return type

[**ObjectTargetCollectionResponse**](ObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | successful operation |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  |  -  |
**401** | INVALID_TOKEN  |  -  |
**404** | OBJECT_TARGET_COLLECTION_NOT_FOUND  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

