# ProjectApi

All URIs are relative to *https://api-eu.wikitude.com/cloudrecognition*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getProjects**](ProjectApi.md#getProjects) | **GET** /projects | Get all projects


<a name="getProjects"></a>
# **getProjects**
> List&lt;AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse&gt; getProjects(xVersion, xToken, skip, limit)

Get all projects

Request all projects from your account.

### Example
```java
// Import classes:
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.Configuration;
import org.openapitools.client.models.*;
import org.openapitools.client.api.ProjectApi;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = Configuration.getDefaultApiClient();
    defaultClient.setBasePath("https://api-eu.wikitude.com/cloudrecognition");

    ProjectApi apiInstance = new ProjectApi(defaultClient);
    String xVersion = "3"; // String | The version of the API to be used. Must be set to 3.
    String xToken = "xToken_example"; // String | Your Manager Token.
    Integer skip = 56; // Integer | Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0
    Integer limit = 56; // Integer | Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000
    try {
      List<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse> result = apiInstance.getProjects(xVersion, xToken, skip, limit);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling ProjectApi#getProjects");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **xVersion** | **String**| The version of the API to be used. Must be set to 3. |
 **xToken** | **String**| Your Manager Token. |
 **skip** | **Integer**| Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 | [optional]
 **limit** | **Integer**| Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 | [optional]

### Return type

[**List&lt;AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse&gt;**](AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

### HTTP response details
| Status code | Description | Response headers |
|-------------|-------------|------------------|
**200** | The Array of Projects in your account |  -  |
**400** | HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  |  -  |
**401** | INVALID_TOKEN  |  -  |
**500** | INTERNAL_SERVER_ERROR  |  -  |

