/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.GenerateHeatmapBody;
import org.openapitools.client.model.GenerateHeatmapResponse;
import org.openapitools.client.model.GenerateHeatmapStatusResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HeatmapApi {
    private ApiClient localVarApiClient;

    public HeatmapApi() {
        this(Configuration.getDefaultApiClient());
    }

    public HeatmapApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for generateHeatmap
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param generateHeatmapBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateHeatmapCall(String xVersion, String xToken, String contentType, GenerateHeatmapBody generateHeatmapBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = generateHeatmapBody;

        // create path and map variables
        String localVarPath = "/heatmap";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call generateHeatmapValidateBeforeCall(String xVersion, String xToken, String contentType, GenerateHeatmapBody generateHeatmapBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling generateHeatmap(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling generateHeatmap(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling generateHeatmap(Async)");
        }
        
        // verify the required parameter 'generateHeatmapBody' is set
        if (generateHeatmapBody == null) {
            throw new ApiException("Missing the required parameter 'generateHeatmapBody' when calling generateHeatmap(Async)");
        }
        

        okhttp3.Call localVarCall = generateHeatmapCall(xVersion, xToken, contentType, generateHeatmapBody, _callback);
        return localVarCall;

    }

    /**
     * Generate Heatmap
     * Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param generateHeatmapBody  (required)
     * @return GenerateHeatmapResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR </td><td>  -  </td></tr>
     </table>
     */
    public GenerateHeatmapResponse generateHeatmap(String xVersion, String xToken, String contentType, GenerateHeatmapBody generateHeatmapBody) throws ApiException {
        ApiResponse<GenerateHeatmapResponse> localVarResp = generateHeatmapWithHttpInfo(xVersion, xToken, contentType, generateHeatmapBody);
        return localVarResp.getData();
    }

    /**
     * Generate Heatmap
     * Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param generateHeatmapBody  (required)
     * @return ApiResponse&lt;GenerateHeatmapResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GenerateHeatmapResponse> generateHeatmapWithHttpInfo(String xVersion, String xToken, String contentType, GenerateHeatmapBody generateHeatmapBody) throws ApiException {
        okhttp3.Call localVarCall = generateHeatmapValidateBeforeCall(xVersion, xToken, contentType, generateHeatmapBody, null);
        Type localVarReturnType = new TypeToken<GenerateHeatmapResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Generate Heatmap (asynchronously)
     * Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param generateHeatmapBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateHeatmapAsync(String xVersion, String xToken, String contentType, GenerateHeatmapBody generateHeatmapBody, final ApiCallback<GenerateHeatmapResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = generateHeatmapValidateBeforeCall(xVersion, xToken, contentType, generateHeatmapBody, _callback);
        Type localVarReturnType = new TypeToken<GenerateHeatmapResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getHeatmapStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a url to the generated heatmap or or an \&quot;error\&quot;-object.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHeatmapStatusCall(String xVersion, String xToken, String generationId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/heatmap/{generationId}"
            .replaceAll("\\{" + "generationId" + "\\}", localVarApiClient.escapeString(generationId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getHeatmapStatusValidateBeforeCall(String xVersion, String xToken, String generationId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getHeatmapStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getHeatmapStatus(Async)");
        }
        
        // verify the required parameter 'generationId' is set
        if (generationId == null) {
            throw new ApiException("Missing the required parameter 'generationId' when calling getHeatmapStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getHeatmapStatusCall(xVersion, xToken, generationId, _callback);
        return localVarCall;

    }

    /**
     * Status - Generate Heatmap
     * Retrieves information status about a particular scheduled heatmap creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return GenerateHeatmapStatusResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a url to the generated heatmap or or an \&quot;error\&quot;-object.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public GenerateHeatmapStatusResponse getHeatmapStatus(String xVersion, String xToken, String generationId) throws ApiException {
        ApiResponse<GenerateHeatmapStatusResponse> localVarResp = getHeatmapStatusWithHttpInfo(xVersion, xToken, generationId);
        return localVarResp.getData();
    }

    /**
     * Status - Generate Heatmap
     * Retrieves information status about a particular scheduled heatmap creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ApiResponse&lt;GenerateHeatmapStatusResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a url to the generated heatmap or or an \&quot;error\&quot;-object.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GenerateHeatmapStatusResponse> getHeatmapStatusWithHttpInfo(String xVersion, String xToken, String generationId) throws ApiException {
        okhttp3.Call localVarCall = getHeatmapStatusValidateBeforeCall(xVersion, xToken, generationId, null);
        Type localVarReturnType = new TypeToken<GenerateHeatmapStatusResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Generate Heatmap (asynchronously)
     * Retrieves information status about a particular scheduled heatmap creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a url to the generated heatmap or or an \&quot;error\&quot;-object.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getHeatmapStatusAsync(String xVersion, String xToken, String generationId, final ApiCallback<GenerateHeatmapStatusResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getHeatmapStatusValidateBeforeCall(xVersion, xToken, generationId, _callback);
        Type localVarReturnType = new TypeToken<GenerateHeatmapStatusResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
