/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import java.math.BigDecimal;
import org.openapitools.client.model.CreateImageTargetsBody;
import org.openapitools.client.model.CreateImageTargetsResponse;
import org.openapitools.client.model.ImageTargetResponse;
import org.openapitools.client.model.UpdateImageTargetBody;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ImageTargetApi {
    private ApiClient localVarApiClient;

    public ImageTargetApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ImageTargetApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for createImageTargets
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param createImageTargetsBody  (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The job of the Target creation task. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; DUPLICATE_TARGETIMAGE_USAGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createImageTargetsCall(String xVersion, String xToken, String contentType, String tcId, List<CreateImageTargetsBody> createImageTargetsBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = createImageTargetsBody;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/targets"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createImageTargetsValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, List<CreateImageTargetsBody> createImageTargetsBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling createImageTargets(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling createImageTargets(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling createImageTargets(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling createImageTargets(Async)");
        }
        

        okhttp3.Call localVarCall = createImageTargetsCall(xVersion, xToken, contentType, tcId, createImageTargetsBody, _callback);
        return localVarCall;

    }

    /**
     * Create Image Targets
     * Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \&quot;Location\&quot;-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \&quot;estimatedLatency\&quot; milliseconds, and poll it afterwards every 10 seconds in case job status is still not \&quot;COMPLETED\&quot;. Once job status is \&quot;COMPLETED\&quot; each item holds a \&quot;target\&quot; attribute of the created target or an \&quot;error\&quot; attribute. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param createImageTargetsBody  (optional)
     * @return CreateImageTargetsResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The job of the Target creation task. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; DUPLICATE_TARGETIMAGE_USAGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public CreateImageTargetsResponse createImageTargets(String xVersion, String xToken, String contentType, String tcId, List<CreateImageTargetsBody> createImageTargetsBody) throws ApiException {
        ApiResponse<CreateImageTargetsResponse> localVarResp = createImageTargetsWithHttpInfo(xVersion, xToken, contentType, tcId, createImageTargetsBody);
        return localVarResp.getData();
    }

    /**
     * Create Image Targets
     * Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \&quot;Location\&quot;-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \&quot;estimatedLatency\&quot; milliseconds, and poll it afterwards every 10 seconds in case job status is still not \&quot;COMPLETED\&quot;. Once job status is \&quot;COMPLETED\&quot; each item holds a \&quot;target\&quot; attribute of the created target or an \&quot;error\&quot; attribute. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param createImageTargetsBody  (optional)
     * @return ApiResponse&lt;CreateImageTargetsResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The job of the Target creation task. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; DUPLICATE_TARGETIMAGE_USAGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CreateImageTargetsResponse> createImageTargetsWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, List<CreateImageTargetsBody> createImageTargetsBody) throws ApiException {
        okhttp3.Call localVarCall = createImageTargetsValidateBeforeCall(xVersion, xToken, contentType, tcId, createImageTargetsBody, null);
        Type localVarReturnType = new TypeToken<CreateImageTargetsResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create Image Targets (asynchronously)
     * Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \&quot;Location\&quot;-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \&quot;estimatedLatency\&quot; milliseconds, and poll it afterwards every 10 seconds in case job status is still not \&quot;COMPLETED\&quot;. Once job status is \&quot;COMPLETED\&quot; each item holds a \&quot;target\&quot; attribute of the created target or an \&quot;error\&quot; attribute. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param createImageTargetsBody  (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The job of the Target creation task. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; DUPLICATE_TARGETIMAGE_USAGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createImageTargetsAsync(String xVersion, String xToken, String contentType, String tcId, List<CreateImageTargetsBody> createImageTargetsBody, final ApiCallback<CreateImageTargetsResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = createImageTargetsValidateBeforeCall(xVersion, xToken, contentType, tcId, createImageTargetsBody, _callback);
        Type localVarReturnType = new TypeToken<CreateImageTargetsResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteImageTarget
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteImageTargetCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/target/{targetId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "targetId" + "\\}", localVarApiClient.escapeString(targetId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteImageTargetValidateBeforeCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling deleteImageTarget(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling deleteImageTarget(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling deleteImageTarget(Async)");
        }
        
        // verify the required parameter 'targetId' is set
        if (targetId == null) {
            throw new ApiException("Missing the required parameter 'targetId' when calling deleteImageTarget(Async)");
        }
        

        okhttp3.Call localVarCall = deleteImageTargetCall(xVersion, xToken, tcId, targetId, _callback);
        return localVarCall;

    }

    /**
     * Delete Image Target
     * Delete a particular Target from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public void deleteImageTarget(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        deleteImageTargetWithHttpInfo(xVersion, xToken, tcId, targetId);
    }

    /**
     * Delete Image Target
     * Delete a particular Target from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> deleteImageTargetWithHttpInfo(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        okhttp3.Call localVarCall = deleteImageTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Delete Image Target (asynchronously)
     * Delete a particular Target from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteImageTargetAsync(String xVersion, String xToken, String tcId, String targetId, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteImageTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for getImageTarget
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/target/{targetId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "targetId" + "\\}", localVarApiClient.escapeString(targetId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getImageTargetValidateBeforeCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getImageTarget(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getImageTarget(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getImageTarget(Async)");
        }
        
        // verify the required parameter 'targetId' is set
        if (targetId == null) {
            throw new ApiException("Missing the required parameter 'targetId' when calling getImageTarget(Async)");
        }
        

        okhttp3.Call localVarCall = getImageTargetCall(xVersion, xToken, tcId, targetId, _callback);
        return localVarCall;

    }

    /**
     * Get Image Target
     * Request a particular Image Target in a particular Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @return ImageTargetResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ImageTargetResponse getImageTarget(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        ApiResponse<ImageTargetResponse> localVarResp = getImageTargetWithHttpInfo(xVersion, xToken, tcId, targetId);
        return localVarResp.getData();
    }

    /**
     * Get Image Target
     * Request a particular Image Target in a particular Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @return ApiResponse&lt;ImageTargetResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ImageTargetResponse> getImageTargetWithHttpInfo(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        okhttp3.Call localVarCall = getImageTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, null);
        Type localVarReturnType = new TypeToken<ImageTargetResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get Image Target (asynchronously)
     * Request a particular Image Target in a particular Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetAsync(String xVersion, String xToken, String tcId, String targetId, final ApiCallback<ImageTargetResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getImageTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, _callback);
        Type localVarReturnType = new TypeToken<ImageTargetResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getImageTargetStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a list of \&quot;creation-items\&quot;. Every item has an \&quot;input\&quot;-attribute that holds the JSON-Object used for creation (equals item at this index in post-body). Once status is \&quot;COMPLETED\&quot; every item also contains a \&quot;target\&quot;-attribute (same style as in successful single target creation) or an \&quot;error\&quot;-object (same as status 400 error JSON response in single target creation).  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetStatusCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/generation/targets/{generationId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "generationId" + "\\}", localVarApiClient.escapeString(generationId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getImageTargetStatusValidateBeforeCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getImageTargetStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getImageTargetStatus(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getImageTargetStatus(Async)");
        }
        
        // verify the required parameter 'generationId' is set
        if (generationId == null) {
            throw new ApiException("Missing the required parameter 'generationId' when calling getImageTargetStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getImageTargetStatusCall(xVersion, xToken, tcId, generationId, _callback);
        return localVarCall;

    }

    /**
     * Status - Image Targets Creation
     * Retrieves information status about a particular scheduled targets creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return CreateImageTargetsResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a list of \&quot;creation-items\&quot;. Every item has an \&quot;input\&quot;-attribute that holds the JSON-Object used for creation (equals item at this index in post-body). Once status is \&quot;COMPLETED\&quot; every item also contains a \&quot;target\&quot;-attribute (same style as in successful single target creation) or an \&quot;error\&quot;-object (same as status 400 error JSON response in single target creation).  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public CreateImageTargetsResponse getImageTargetStatus(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        ApiResponse<CreateImageTargetsResponse> localVarResp = getImageTargetStatusWithHttpInfo(xVersion, xToken, tcId, generationId);
        return localVarResp.getData();
    }

    /**
     * Status - Image Targets Creation
     * Retrieves information status about a particular scheduled targets creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ApiResponse&lt;CreateImageTargetsResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a list of \&quot;creation-items\&quot;. Every item has an \&quot;input\&quot;-attribute that holds the JSON-Object used for creation (equals item at this index in post-body). Once status is \&quot;COMPLETED\&quot; every item also contains a \&quot;target\&quot;-attribute (same style as in successful single target creation) or an \&quot;error\&quot;-object (same as status 400 error JSON response in single target creation).  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CreateImageTargetsResponse> getImageTargetStatusWithHttpInfo(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        okhttp3.Call localVarCall = getImageTargetStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, null);
        Type localVarReturnType = new TypeToken<CreateImageTargetsResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Image Targets Creation (asynchronously)
     * Retrieves information status about a particular scheduled targets creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information, including \&quot;status\&quot;, \&quot;payload\&quot; attribute, \&quot;estimatedEnd\&quot;, \&quot;estimatedLatency\&quot; attributes. The \&quot;payload\&quot; contains a list of \&quot;creation-items\&quot;. Every item has an \&quot;input\&quot;-attribute that holds the JSON-Object used for creation (equals item at this index in post-body). Once status is \&quot;COMPLETED\&quot; every item also contains a \&quot;target\&quot;-attribute (same style as in successful single target creation) or an \&quot;error\&quot;-object (same as status 400 error JSON response in single target creation).  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetStatusAsync(String xVersion, String xToken, String tcId, String generationId, final ApiCallback<CreateImageTargetsResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getImageTargetStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, _callback);
        Type localVarReturnType = new TypeToken<CreateImageTargetsResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getImageTargets
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param sortby Targets may be sorted by &#39;name&#39;, &#39;creDat&#39;, &#39;modDat&#39;, &#39;rating&#39;. Default value: &#39;creDat&#39; (optional)
     * @param sortorder Targets may be sorted ascending (&#39;asc&#39;) or descending (&#39;desc&#39;). Default value: &#39;desc&#39; (optional)
     * @param skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0 (optional)
     * @param limit Set to 0 for &#39;all targets&#39; or use positive value to define max. amount of targets to return. Default value: 0 (optional)
     * @param s The search string to look for in target names. (optional)
     * @param addHasAugmentations Add the hasAugmentations property. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Targets in the Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetsCall(String xVersion, String xToken, String tcId, String sortby, String sortorder, BigDecimal skip, BigDecimal limit, String s, Boolean addHasAugmentations, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/target"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (sortby != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("sortby", sortby));
        }

        if (sortorder != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("sortorder", sortorder));
        }

        if (skip != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("skip", skip));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (s != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("s", s));
        }

        if (addHasAugmentations != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("addHasAugmentations", addHasAugmentations));
        }

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getImageTargetsValidateBeforeCall(String xVersion, String xToken, String tcId, String sortby, String sortorder, BigDecimal skip, BigDecimal limit, String s, Boolean addHasAugmentations, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getImageTargets(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getImageTargets(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getImageTargets(Async)");
        }
        

        okhttp3.Call localVarCall = getImageTargetsCall(xVersion, xToken, tcId, sortby, sortorder, skip, limit, s, addHasAugmentations, _callback);
        return localVarCall;

    }

    /**
     * Get Image Targets
     * Request all Image Targets in a Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param sortby Targets may be sorted by &#39;name&#39;, &#39;creDat&#39;, &#39;modDat&#39;, &#39;rating&#39;. Default value: &#39;creDat&#39; (optional)
     * @param sortorder Targets may be sorted ascending (&#39;asc&#39;) or descending (&#39;desc&#39;). Default value: &#39;desc&#39; (optional)
     * @param skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0 (optional)
     * @param limit Set to 0 for &#39;all targets&#39; or use positive value to define max. amount of targets to return. Default value: 0 (optional)
     * @param s The search string to look for in target names. (optional)
     * @param addHasAugmentations Add the hasAugmentations property. (optional)
     * @return List&lt;ImageTargetResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Targets in the Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public List<ImageTargetResponse> getImageTargets(String xVersion, String xToken, String tcId, String sortby, String sortorder, BigDecimal skip, BigDecimal limit, String s, Boolean addHasAugmentations) throws ApiException {
        ApiResponse<List<ImageTargetResponse>> localVarResp = getImageTargetsWithHttpInfo(xVersion, xToken, tcId, sortby, sortorder, skip, limit, s, addHasAugmentations);
        return localVarResp.getData();
    }

    /**
     * Get Image Targets
     * Request all Image Targets in a Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param sortby Targets may be sorted by &#39;name&#39;, &#39;creDat&#39;, &#39;modDat&#39;, &#39;rating&#39;. Default value: &#39;creDat&#39; (optional)
     * @param sortorder Targets may be sorted ascending (&#39;asc&#39;) or descending (&#39;desc&#39;). Default value: &#39;desc&#39; (optional)
     * @param skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0 (optional)
     * @param limit Set to 0 for &#39;all targets&#39; or use positive value to define max. amount of targets to return. Default value: 0 (optional)
     * @param s The search string to look for in target names. (optional)
     * @param addHasAugmentations Add the hasAugmentations property. (optional)
     * @return ApiResponse&lt;List&lt;ImageTargetResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Targets in the Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ImageTargetResponse>> getImageTargetsWithHttpInfo(String xVersion, String xToken, String tcId, String sortby, String sortorder, BigDecimal skip, BigDecimal limit, String s, Boolean addHasAugmentations) throws ApiException {
        okhttp3.Call localVarCall = getImageTargetsValidateBeforeCall(xVersion, xToken, tcId, sortby, sortorder, skip, limit, s, addHasAugmentations, null);
        Type localVarReturnType = new TypeToken<List<ImageTargetResponse>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get Image Targets (asynchronously)
     * Request all Image Targets in a Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param sortby Targets may be sorted by &#39;name&#39;, &#39;creDat&#39;, &#39;modDat&#39;, &#39;rating&#39;. Default value: &#39;creDat&#39; (optional)
     * @param sortorder Targets may be sorted ascending (&#39;asc&#39;) or descending (&#39;desc&#39;). Default value: &#39;desc&#39; (optional)
     * @param skip Set 0 to start with first target, set e.g. to 2 to skip first 2 targets. Default value: 0 (optional)
     * @param limit Set to 0 for &#39;all targets&#39; or use positive value to define max. amount of targets to return. Default value: 0 (optional)
     * @param s The search string to look for in target names. (optional)
     * @param addHasAugmentations Add the hasAugmentations property. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Targets in the Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetsAsync(String xVersion, String xToken, String tcId, String sortby, String sortorder, BigDecimal skip, BigDecimal limit, String s, Boolean addHasAugmentations, final ApiCallback<List<ImageTargetResponse>> _callback) throws ApiException {

        okhttp3.Call localVarCall = getImageTargetsValidateBeforeCall(xVersion, xToken, tcId, sortby, sortorder, skip, limit, s, addHasAugmentations, _callback);
        Type localVarReturnType = new TypeToken<List<ImageTargetResponse>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for updateImageTarget
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param updateImageTargetBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call updateImageTargetCall(String xVersion, String xToken, String contentType, String tcId, String targetId, UpdateImageTargetBody updateImageTargetBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = updateImageTargetBody;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/target/{targetId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "targetId" + "\\}", localVarApiClient.escapeString(targetId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call updateImageTargetValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, String targetId, UpdateImageTargetBody updateImageTargetBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling updateImageTarget(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling updateImageTarget(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling updateImageTarget(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling updateImageTarget(Async)");
        }
        
        // verify the required parameter 'targetId' is set
        if (targetId == null) {
            throw new ApiException("Missing the required parameter 'targetId' when calling updateImageTarget(Async)");
        }
        
        // verify the required parameter 'updateImageTargetBody' is set
        if (updateImageTargetBody == null) {
            throw new ApiException("Missing the required parameter 'updateImageTargetBody' when calling updateImageTarget(Async)");
        }
        

        okhttp3.Call localVarCall = updateImageTargetCall(xVersion, xToken, contentType, tcId, targetId, updateImageTargetBody, _callback);
        return localVarCall;

    }

    /**
     * Update Image Target
     * Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param updateImageTargetBody  (required)
     * @return ImageTargetResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ImageTargetResponse updateImageTarget(String xVersion, String xToken, String contentType, String tcId, String targetId, UpdateImageTargetBody updateImageTargetBody) throws ApiException {
        ApiResponse<ImageTargetResponse> localVarResp = updateImageTargetWithHttpInfo(xVersion, xToken, contentType, tcId, targetId, updateImageTargetBody);
        return localVarResp.getData();
    }

    /**
     * Update Image Target
     * Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param updateImageTargetBody  (required)
     * @return ApiResponse&lt;ImageTargetResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ImageTargetResponse> updateImageTargetWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, String targetId, UpdateImageTargetBody updateImageTargetBody) throws ApiException {
        okhttp3.Call localVarCall = updateImageTargetValidateBeforeCall(xVersion, xToken, contentType, tcId, targetId, updateImageTargetBody, null);
        Type localVarReturnType = new TypeToken<ImageTargetResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Update Image Target (asynchronously)
     * Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param targetId Unique identifier of the Image Target. (required)
     * @param updateImageTargetBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call updateImageTargetAsync(String xVersion, String xToken, String contentType, String tcId, String targetId, UpdateImageTargetBody updateImageTargetBody, final ApiCallback<ImageTargetResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = updateImageTargetValidateBeforeCall(xVersion, xToken, contentType, tcId, targetId, updateImageTargetBody, _callback);
        Type localVarReturnType = new TypeToken<ImageTargetResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
