/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.CloudArchiveGenerationResponse;
import org.openapitools.client.model.CreateImageTargetCollectionBody;
import org.openapitools.client.model.GenerateWTCBody;
import org.openapitools.client.model.GenerateWTCStatusResponse;
import org.openapitools.client.model.ImageTargetCollectionResponse;
import org.openapitools.client.model.SimilarityCheckBody;
import org.openapitools.client.model.SimilarityCheckResponse;
import org.openapitools.client.model.SimilarityCheckStatusResponse;
import org.openapitools.client.model.UpdateImageTargetCollectionBody;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ImageTargetCollectionApi {
    private ApiClient localVarApiClient;

    public ImageTargetCollectionApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ImageTargetCollectionApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for createImageTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createImageTargetCollectionBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The newly created TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createImageTargetCollectionCall(String xVersion, String xToken, String contentType, CreateImageTargetCollectionBody createImageTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = createImageTargetCollectionBody;

        // create path and map variables
        String localVarPath = "/targetCollection";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createImageTargetCollectionValidateBeforeCall(String xVersion, String xToken, String contentType, CreateImageTargetCollectionBody createImageTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling createImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling createImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling createImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'createImageTargetCollectionBody' is set
        if (createImageTargetCollectionBody == null) {
            throw new ApiException("Missing the required parameter 'createImageTargetCollectionBody' when calling createImageTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = createImageTargetCollectionCall(xVersion, xToken, contentType, createImageTargetCollectionBody, _callback);
        return localVarCall;

    }

    /**
     * Create Image Target Collection
     * Create a new target collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createImageTargetCollectionBody  (required)
     * @return ImageTargetCollectionResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The newly created TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ImageTargetCollectionResponse createImageTargetCollection(String xVersion, String xToken, String contentType, CreateImageTargetCollectionBody createImageTargetCollectionBody) throws ApiException {
        ApiResponse<ImageTargetCollectionResponse> localVarResp = createImageTargetCollectionWithHttpInfo(xVersion, xToken, contentType, createImageTargetCollectionBody);
        return localVarResp.getData();
    }

    /**
     * Create Image Target Collection
     * Create a new target collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createImageTargetCollectionBody  (required)
     * @return ApiResponse&lt;ImageTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The newly created TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ImageTargetCollectionResponse> createImageTargetCollectionWithHttpInfo(String xVersion, String xToken, String contentType, CreateImageTargetCollectionBody createImageTargetCollectionBody) throws ApiException {
        okhttp3.Call localVarCall = createImageTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, createImageTargetCollectionBody, null);
        Type localVarReturnType = new TypeToken<ImageTargetCollectionResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create Image Target Collection (asynchronously)
     * Create a new target collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createImageTargetCollectionBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The newly created TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createImageTargetCollectionAsync(String xVersion, String xToken, String contentType, CreateImageTargetCollectionBody createImageTargetCollectionBody, final ApiCallback<ImageTargetCollectionResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = createImageTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, createImageTargetCollectionBody, _callback);
        Type localVarReturnType = new TypeToken<ImageTargetCollectionResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteImageTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteImageTargetCollectionCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteImageTargetCollectionValidateBeforeCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling deleteImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling deleteImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling deleteImageTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = deleteImageTargetCollectionCall(xVersion, xToken, tcId, _callback);
        return localVarCall;

    }

    /**
     * Delete Image Target Collection
     * Delete a particular target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public void deleteImageTargetCollection(String xVersion, String xToken, String tcId) throws ApiException {
        deleteImageTargetCollectionWithHttpInfo(xVersion, xToken, tcId);
    }

    /**
     * Delete Image Target Collection
     * Delete a particular target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> deleteImageTargetCollectionWithHttpInfo(String xVersion, String xToken, String tcId) throws ApiException {
        okhttp3.Call localVarCall = deleteImageTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Delete Image Target Collection (asynchronously)
     * Delete a particular target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteImageTargetCollectionAsync(String xVersion, String xToken, String tcId, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteImageTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for generateCloudArchive
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> successful execution </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_UP_TO_DATE&lt;br/&gt; TARGET_COLLECTION_GENERATION_PENDING&lt;br/&gt; TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateCloudArchiveCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/generation/cloudarchive"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call generateCloudArchiveValidateBeforeCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling generateCloudArchive(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling generateCloudArchive(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling generateCloudArchive(Async)");
        }
        

        okhttp3.Call localVarCall = generateCloudArchiveCall(xVersion, xToken, tcId, _callback);
        return localVarCall;

    }

    /**
     * Generate Cloud Archive
     * DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \&quot;deprecated\&quot; since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @return CloudArchiveGenerationResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> successful execution </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_UP_TO_DATE&lt;br/&gt; TARGET_COLLECTION_GENERATION_PENDING&lt;br/&gt; TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public CloudArchiveGenerationResponse generateCloudArchive(String xVersion, String xToken, String tcId) throws ApiException {
        ApiResponse<CloudArchiveGenerationResponse> localVarResp = generateCloudArchiveWithHttpInfo(xVersion, xToken, tcId);
        return localVarResp.getData();
    }

    /**
     * Generate Cloud Archive
     * DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \&quot;deprecated\&quot; since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @return ApiResponse&lt;CloudArchiveGenerationResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> successful execution </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_UP_TO_DATE&lt;br/&gt; TARGET_COLLECTION_GENERATION_PENDING&lt;br/&gt; TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CloudArchiveGenerationResponse> generateCloudArchiveWithHttpInfo(String xVersion, String xToken, String tcId) throws ApiException {
        okhttp3.Call localVarCall = generateCloudArchiveValidateBeforeCall(xVersion, xToken, tcId, null);
        Type localVarReturnType = new TypeToken<CloudArchiveGenerationResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Generate Cloud Archive (asynchronously)
     * DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \&quot;deprecated\&quot; since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> successful execution </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_UP_TO_DATE&lt;br/&gt; TARGET_COLLECTION_GENERATION_PENDING&lt;br/&gt; TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateCloudArchiveAsync(String xVersion, String xToken, String tcId, final ApiCallback<CloudArchiveGenerationResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = generateCloudArchiveValidateBeforeCall(xVersion, xToken, tcId, _callback);
        Type localVarReturnType = new TypeToken<CloudArchiveGenerationResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for generateWTC
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generateWTCBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_EMPTY&lt;br/&gt; TARGET_COLLECTION_TOO_LARGE_FOR_WTC  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateWTCCall(String xVersion, String xToken, String contentType, String tcId, GenerateWTCBody generateWTCBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = generateWTCBody;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/generation/wtc"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call generateWTCValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, GenerateWTCBody generateWTCBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling generateWTC(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling generateWTC(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling generateWTC(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling generateWTC(Async)");
        }
        
        // verify the required parameter 'generateWTCBody' is set
        if (generateWTCBody == null) {
            throw new ApiException("Missing the required parameter 'generateWTCBody' when calling generateWTC(Async)");
        }
        

        okhttp3.Call localVarCall = generateWTCCall(xVersion, xToken, contentType, tcId, generateWTCBody, _callback);
        return localVarCall;

    }

    /**
     * Generate WTC
     * Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generateWTCBody  (required)
     * @return GenerateWTCStatusResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_EMPTY&lt;br/&gt; TARGET_COLLECTION_TOO_LARGE_FOR_WTC  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public GenerateWTCStatusResponse generateWTC(String xVersion, String xToken, String contentType, String tcId, GenerateWTCBody generateWTCBody) throws ApiException {
        ApiResponse<GenerateWTCStatusResponse> localVarResp = generateWTCWithHttpInfo(xVersion, xToken, contentType, tcId, generateWTCBody);
        return localVarResp.getData();
    }

    /**
     * Generate WTC
     * Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generateWTCBody  (required)
     * @return ApiResponse&lt;GenerateWTCStatusResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_EMPTY&lt;br/&gt; TARGET_COLLECTION_TOO_LARGE_FOR_WTC  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GenerateWTCStatusResponse> generateWTCWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, GenerateWTCBody generateWTCBody) throws ApiException {
        okhttp3.Call localVarCall = generateWTCValidateBeforeCall(xVersion, xToken, contentType, tcId, generateWTCBody, null);
        Type localVarReturnType = new TypeToken<GenerateWTCStatusResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Generate WTC (asynchronously)
     * Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generateWTCBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> TARGET_COLLECTION_IS_EMPTY&lt;br/&gt; TARGET_COLLECTION_TOO_LARGE_FOR_WTC  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateWTCAsync(String xVersion, String xToken, String contentType, String tcId, GenerateWTCBody generateWTCBody, final ApiCallback<GenerateWTCStatusResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = generateWTCValidateBeforeCall(xVersion, xToken, contentType, tcId, generateWTCBody, _callback);
        Type localVarReturnType = new TypeToken<GenerateWTCStatusResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getCloudArchiveStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation job details. In case JSON attribute status is \&quot;COMPLETED\&quot; the generation finished.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCloudArchiveStatusCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/generation/cloudarchive/{generationId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "generationId" + "\\}", localVarApiClient.escapeString(generationId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getCloudArchiveStatusValidateBeforeCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getCloudArchiveStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getCloudArchiveStatus(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getCloudArchiveStatus(Async)");
        }
        
        // verify the required parameter 'generationId' is set
        if (generationId == null) {
            throw new ApiException("Missing the required parameter 'generationId' when calling getCloudArchiveStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getCloudArchiveStatusCall(xVersion, xToken, tcId, generationId, _callback);
        return localVarCall;

    }

    /**
     * Status - Generate Cloud Archive
     * Retrieves information status about a particular scheduled cloud archive generation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return CloudArchiveGenerationResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation job details. In case JSON attribute status is \&quot;COMPLETED\&quot; the generation finished.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public CloudArchiveGenerationResponse getCloudArchiveStatus(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        ApiResponse<CloudArchiveGenerationResponse> localVarResp = getCloudArchiveStatusWithHttpInfo(xVersion, xToken, tcId, generationId);
        return localVarResp.getData();
    }

    /**
     * Status - Generate Cloud Archive
     * Retrieves information status about a particular scheduled cloud archive generation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ApiResponse&lt;CloudArchiveGenerationResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation job details. In case JSON attribute status is \&quot;COMPLETED\&quot; the generation finished.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<CloudArchiveGenerationResponse> getCloudArchiveStatusWithHttpInfo(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        okhttp3.Call localVarCall = getCloudArchiveStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, null);
        Type localVarReturnType = new TypeToken<CloudArchiveGenerationResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Generate Cloud Archive (asynchronously)
     * Retrieves information status about a particular scheduled cloud archive generation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation job details. In case JSON attribute status is \&quot;COMPLETED\&quot; the generation finished.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getCloudArchiveStatusAsync(String xVersion, String xToken, String tcId, String generationId, final ApiCallback<CloudArchiveGenerationResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getCloudArchiveStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, _callback);
        Type localVarReturnType = new TypeToken<CloudArchiveGenerationResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getImageTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetCollectionCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getImageTargetCollectionValidateBeforeCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getImageTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = getImageTargetCollectionCall(xVersion, xToken, tcId, _callback);
        return localVarCall;

    }

    /**
     * Get Image Target Collection
     * Request a particular target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @return ImageTargetCollectionResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ImageTargetCollectionResponse getImageTargetCollection(String xVersion, String xToken, String tcId) throws ApiException {
        ApiResponse<ImageTargetCollectionResponse> localVarResp = getImageTargetCollectionWithHttpInfo(xVersion, xToken, tcId);
        return localVarResp.getData();
    }

    /**
     * Get Image Target Collection
     * Request a particular target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @return ApiResponse&lt;ImageTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ImageTargetCollectionResponse> getImageTargetCollectionWithHttpInfo(String xVersion, String xToken, String tcId) throws ApiException {
        okhttp3.Call localVarCall = getImageTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, null);
        Type localVarReturnType = new TypeToken<ImageTargetCollectionResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get Image Target Collection (asynchronously)
     * Request a particular target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested TargetCollection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetCollectionAsync(String xVersion, String xToken, String tcId, final ApiCallback<ImageTargetCollectionResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getImageTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, _callback);
        Type localVarReturnType = new TypeToken<ImageTargetCollectionResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getImageTargetCollections
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Image Target Collections in your account. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetCollectionsCall(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (skip != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("skip", skip));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getImageTargetCollectionsValidateBeforeCall(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getImageTargetCollections(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getImageTargetCollections(Async)");
        }
        

        okhttp3.Call localVarCall = getImageTargetCollectionsCall(xVersion, xToken, skip, limit, _callback);
        return localVarCall;

    }

    /**
     * Get all Image Target Collections
     * Request all target collections from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @return List&lt;ImageTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Image Target Collections in your account. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public List<ImageTargetCollectionResponse> getImageTargetCollections(String xVersion, String xToken, Integer skip, Integer limit) throws ApiException {
        ApiResponse<List<ImageTargetCollectionResponse>> localVarResp = getImageTargetCollectionsWithHttpInfo(xVersion, xToken, skip, limit);
        return localVarResp.getData();
    }

    /**
     * Get all Image Target Collections
     * Request all target collections from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @return ApiResponse&lt;List&lt;ImageTargetCollectionResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Image Target Collections in your account. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ImageTargetCollectionResponse>> getImageTargetCollectionsWithHttpInfo(String xVersion, String xToken, Integer skip, Integer limit) throws ApiException {
        okhttp3.Call localVarCall = getImageTargetCollectionsValidateBeforeCall(xVersion, xToken, skip, limit, null);
        Type localVarReturnType = new TypeToken<List<ImageTargetCollectionResponse>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get all Image Target Collections (asynchronously)
     * Request all target collections from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Image Target Collections in your account. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getImageTargetCollectionsAsync(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback<List<ImageTargetCollectionResponse>> _callback) throws ApiException {

        okhttp3.Call localVarCall = getImageTargetCollectionsValidateBeforeCall(xVersion, xToken, skip, limit, _callback);
        Type localVarReturnType = new TypeToken<List<ImageTargetCollectionResponse>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getSimilarityCheckStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information as JSON with \&quot;id\&quot;, \&quot;status\&quot;, \&quot;inputParams\&quot;, \&quot;created\&quot; and \&quot;estimatedLatency\&quot; attributes. In case status is \&quot;FAILED\&quot; and \&quot;error\&quot; attribute is added to provide more details. Once status is \&quot;COMPLETED\&quot; a \&quot;payload\&quot; attribute holds the list of images where each of them has an additional \&quot;candidates\&quot;-attribute in case of success or an \&quot;error\&quot;-object in case an unexpected error occurred. A candidate has a \&quot;targetName\&quot; and a \&quot;score\&quot; value between 0 and 1, where a large score means a high similarity. Every job has an \&quot;input\&quot;-attribute holding the JSON-Object used for creation (same information as used in POST-body plus \&quot;tcId\&quot;). Life cycle of a job is SCHEDULED -&gt; RUNNING -&gt; COMPLETED/FAILED.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSimilarityCheckStatusCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/similarity/{generationId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "generationId" + "\\}", localVarApiClient.escapeString(generationId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getSimilarityCheckStatusValidateBeforeCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getSimilarityCheckStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getSimilarityCheckStatus(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getSimilarityCheckStatus(Async)");
        }
        
        // verify the required parameter 'generationId' is set
        if (generationId == null) {
            throw new ApiException("Missing the required parameter 'generationId' when calling getSimilarityCheckStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getSimilarityCheckStatusCall(xVersion, xToken, tcId, generationId, _callback);
        return localVarCall;

    }

    /**
     * Status - Similarity Check
     * Retrieves information status of a particular scheduled \&quot;Similarity Check\&quot;.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return SimilarityCheckStatusResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information as JSON with \&quot;id\&quot;, \&quot;status\&quot;, \&quot;inputParams\&quot;, \&quot;created\&quot; and \&quot;estimatedLatency\&quot; attributes. In case status is \&quot;FAILED\&quot; and \&quot;error\&quot; attribute is added to provide more details. Once status is \&quot;COMPLETED\&quot; a \&quot;payload\&quot; attribute holds the list of images where each of them has an additional \&quot;candidates\&quot;-attribute in case of success or an \&quot;error\&quot;-object in case an unexpected error occurred. A candidate has a \&quot;targetName\&quot; and a \&quot;score\&quot; value between 0 and 1, where a large score means a high similarity. Every job has an \&quot;input\&quot;-attribute holding the JSON-Object used for creation (same information as used in POST-body plus \&quot;tcId\&quot;). Life cycle of a job is SCHEDULED -&gt; RUNNING -&gt; COMPLETED/FAILED.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public SimilarityCheckStatusResponse getSimilarityCheckStatus(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        ApiResponse<SimilarityCheckStatusResponse> localVarResp = getSimilarityCheckStatusWithHttpInfo(xVersion, xToken, tcId, generationId);
        return localVarResp.getData();
    }

    /**
     * Status - Similarity Check
     * Retrieves information status of a particular scheduled \&quot;Similarity Check\&quot;.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ApiResponse&lt;SimilarityCheckStatusResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information as JSON with \&quot;id\&quot;, \&quot;status\&quot;, \&quot;inputParams\&quot;, \&quot;created\&quot; and \&quot;estimatedLatency\&quot; attributes. In case status is \&quot;FAILED\&quot; and \&quot;error\&quot; attribute is added to provide more details. Once status is \&quot;COMPLETED\&quot; a \&quot;payload\&quot; attribute holds the list of images where each of them has an additional \&quot;candidates\&quot;-attribute in case of success or an \&quot;error\&quot;-object in case an unexpected error occurred. A candidate has a \&quot;targetName\&quot; and a \&quot;score\&quot; value between 0 and 1, where a large score means a high similarity. Every job has an \&quot;input\&quot;-attribute holding the JSON-Object used for creation (same information as used in POST-body plus \&quot;tcId\&quot;). Life cycle of a job is SCHEDULED -&gt; RUNNING -&gt; COMPLETED/FAILED.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SimilarityCheckStatusResponse> getSimilarityCheckStatusWithHttpInfo(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        okhttp3.Call localVarCall = getSimilarityCheckStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, null);
        Type localVarReturnType = new TypeToken<SimilarityCheckStatusResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Similarity Check (asynchronously)
     * Retrieves information status of a particular scheduled \&quot;Similarity Check\&quot;.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested job information as JSON with \&quot;id\&quot;, \&quot;status\&quot;, \&quot;inputParams\&quot;, \&quot;created\&quot; and \&quot;estimatedLatency\&quot; attributes. In case status is \&quot;FAILED\&quot; and \&quot;error\&quot; attribute is added to provide more details. Once status is \&quot;COMPLETED\&quot; a \&quot;payload\&quot; attribute holds the list of images where each of them has an additional \&quot;candidates\&quot;-attribute in case of success or an \&quot;error\&quot;-object in case an unexpected error occurred. A candidate has a \&quot;targetName\&quot; and a \&quot;score\&quot; value between 0 and 1, where a large score means a high similarity. Every job has an \&quot;input\&quot;-attribute holding the JSON-Object used for creation (same information as used in POST-body plus \&quot;tcId\&quot;). Life cycle of a job is SCHEDULED -&gt; RUNNING -&gt; COMPLETED/FAILED.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getSimilarityCheckStatusAsync(String xVersion, String xToken, String tcId, String generationId, final ApiCallback<SimilarityCheckStatusResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getSimilarityCheckStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, _callback);
        Type localVarReturnType = new TypeToken<SimilarityCheckStatusResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getWTCStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getWTCStatusCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/generation/wtc/{generationId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "generationId" + "\\}", localVarApiClient.escapeString(generationId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getWTCStatusValidateBeforeCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getWTCStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getWTCStatus(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getWTCStatus(Async)");
        }
        
        // verify the required parameter 'generationId' is set
        if (generationId == null) {
            throw new ApiException("Missing the required parameter 'generationId' when calling getWTCStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getWTCStatusCall(xVersion, xToken, tcId, generationId, _callback);
        return localVarCall;

    }

    /**
     * Status - Generate WTC
     * Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return GenerateWTCStatusResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public GenerateWTCStatusResponse getWTCStatus(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        ApiResponse<GenerateWTCStatusResponse> localVarResp = getWTCStatusWithHttpInfo(xVersion, xToken, tcId, generationId);
        return localVarResp.getData();
    }

    /**
     * Status - Generate WTC
     * Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ApiResponse&lt;GenerateWTCStatusResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<GenerateWTCStatusResponse> getWTCStatusWithHttpInfo(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        okhttp3.Call localVarCall = getWTCStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, null);
        Type localVarReturnType = new TypeToken<GenerateWTCStatusResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Generate WTC (asynchronously)
     * Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The particular requested generation status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getWTCStatusAsync(String xVersion, String xToken, String tcId, String generationId, final ApiCallback<GenerateWTCStatusResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getWTCStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, _callback);
        Type localVarReturnType = new TypeToken<GenerateWTCStatusResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for similarityCheck
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param similarityCheckBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Response Code with header value \&quot;Location\&quot; which points to the \&quot;Status - Similarity Check\&quot; endpoint. Body holds async job information. A JSON Object with an \&quot;id\&quot; (for \&quot;Status - Similarity Check\&quot; GET endpoint), \&quot;inputParams\&quot; (JSON Object holding the \&quot;images\&quot; as a list and the tcId), \&quot;status\&quot; (\&quot;SCHEDULED\&quot;, \&quot;COMPLETED\&quot;, \&quot;FAILED\&quot;), \&quot;estimatedLatency\&quot; and \&quot;created\&quot; timestamps.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call similarityCheckCall(String xVersion, String xToken, String contentType, String tcId, SimilarityCheckBody similarityCheckBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = similarityCheckBody;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}/similarity"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call similarityCheckValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, SimilarityCheckBody similarityCheckBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling similarityCheck(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling similarityCheck(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling similarityCheck(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling similarityCheck(Async)");
        }
        
        // verify the required parameter 'similarityCheckBody' is set
        if (similarityCheckBody == null) {
            throw new ApiException("Missing the required parameter 'similarityCheckBody' when calling similarityCheck(Async)");
        }
        

        okhttp3.Call localVarCall = similarityCheckCall(xVersion, xToken, contentType, tcId, similarityCheckBody, _callback);
        return localVarCall;

    }

    /**
     * Similarity Check
     * Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \&quot;candidates\&quot; with a similarity \&quot;score\&quot; are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \&quot;maxCandidates\&quot; to define the maximum amount of candidates to return for an image. Response header value \&quot;Location\&quot; directly points to the right \&quot;Status - Similarity Check\&quot; endpoint. Best practice is to trigger \&quot;Similarity Check\&quot;, wait for \&quot;estimatedLatency\&quot; milliseconds and poll \&quot;Status - Similarity Check\&quot; endpoint every 5 seconds until its \&quot;status\&quot; is \&quot;COMPLETED\&quot;. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param similarityCheckBody  (required)
     * @return SimilarityCheckResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Response Code with header value \&quot;Location\&quot; which points to the \&quot;Status - Similarity Check\&quot; endpoint. Body holds async job information. A JSON Object with an \&quot;id\&quot; (for \&quot;Status - Similarity Check\&quot; GET endpoint), \&quot;inputParams\&quot; (JSON Object holding the \&quot;images\&quot; as a list and the tcId), \&quot;status\&quot; (\&quot;SCHEDULED\&quot;, \&quot;COMPLETED\&quot;, \&quot;FAILED\&quot;), \&quot;estimatedLatency\&quot; and \&quot;created\&quot; timestamps.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public SimilarityCheckResponse similarityCheck(String xVersion, String xToken, String contentType, String tcId, SimilarityCheckBody similarityCheckBody) throws ApiException {
        ApiResponse<SimilarityCheckResponse> localVarResp = similarityCheckWithHttpInfo(xVersion, xToken, contentType, tcId, similarityCheckBody);
        return localVarResp.getData();
    }

    /**
     * Similarity Check
     * Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \&quot;candidates\&quot; with a similarity \&quot;score\&quot; are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \&quot;maxCandidates\&quot; to define the maximum amount of candidates to return for an image. Response header value \&quot;Location\&quot; directly points to the right \&quot;Status - Similarity Check\&quot; endpoint. Best practice is to trigger \&quot;Similarity Check\&quot;, wait for \&quot;estimatedLatency\&quot; milliseconds and poll \&quot;Status - Similarity Check\&quot; endpoint every 5 seconds until its \&quot;status\&quot; is \&quot;COMPLETED\&quot;. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param similarityCheckBody  (required)
     * @return ApiResponse&lt;SimilarityCheckResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Response Code with header value \&quot;Location\&quot; which points to the \&quot;Status - Similarity Check\&quot; endpoint. Body holds async job information. A JSON Object with an \&quot;id\&quot; (for \&quot;Status - Similarity Check\&quot; GET endpoint), \&quot;inputParams\&quot; (JSON Object holding the \&quot;images\&quot; as a list and the tcId), \&quot;status\&quot; (\&quot;SCHEDULED\&quot;, \&quot;COMPLETED\&quot;, \&quot;FAILED\&quot;), \&quot;estimatedLatency\&quot; and \&quot;created\&quot; timestamps.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<SimilarityCheckResponse> similarityCheckWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, SimilarityCheckBody similarityCheckBody) throws ApiException {
        okhttp3.Call localVarCall = similarityCheckValidateBeforeCall(xVersion, xToken, contentType, tcId, similarityCheckBody, null);
        Type localVarReturnType = new TypeToken<SimilarityCheckResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Similarity Check (asynchronously)
     * Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \&quot;candidates\&quot; with a similarity \&quot;score\&quot; are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \&quot;maxCandidates\&quot; to define the maximum amount of candidates to return for an image. Response header value \&quot;Location\&quot; directly points to the right \&quot;Status - Similarity Check\&quot; endpoint. Best practice is to trigger \&quot;Similarity Check\&quot;, wait for \&quot;estimatedLatency\&quot; milliseconds and poll \&quot;Status - Similarity Check\&quot; endpoint every 5 seconds until its \&quot;status\&quot; is \&quot;COMPLETED\&quot;. 
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param similarityCheckBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Response Code with header value \&quot;Location\&quot; which points to the \&quot;Status - Similarity Check\&quot; endpoint. Body holds async job information. A JSON Object with an \&quot;id\&quot; (for \&quot;Status - Similarity Check\&quot; GET endpoint), \&quot;inputParams\&quot; (JSON Object holding the \&quot;images\&quot; as a list and the tcId), \&quot;status\&quot; (\&quot;SCHEDULED\&quot;, \&quot;COMPLETED\&quot;, \&quot;FAILED\&quot;), \&quot;estimatedLatency\&quot; and \&quot;created\&quot; timestamps.  </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call similarityCheckAsync(String xVersion, String xToken, String contentType, String tcId, SimilarityCheckBody similarityCheckBody, final ApiCallback<SimilarityCheckResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = similarityCheckValidateBeforeCall(xVersion, xToken, contentType, tcId, similarityCheckBody, _callback);
        Type localVarReturnType = new TypeToken<SimilarityCheckResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for updateImageTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param updateImageTargetCollectionBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call updateImageTargetCollectionCall(String xVersion, String xToken, String contentType, String tcId, UpdateImageTargetCollectionBody updateImageTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = updateImageTargetCollectionBody;

        // create path and map variables
        String localVarPath = "/targetCollection/{tcId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call updateImageTargetCollectionValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, UpdateImageTargetCollectionBody updateImageTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling updateImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling updateImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling updateImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling updateImageTargetCollection(Async)");
        }
        
        // verify the required parameter 'updateImageTargetCollectionBody' is set
        if (updateImageTargetCollectionBody == null) {
            throw new ApiException("Missing the required parameter 'updateImageTargetCollectionBody' when calling updateImageTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = updateImageTargetCollectionCall(xVersion, xToken, contentType, tcId, updateImageTargetCollectionBody, _callback);
        return localVarCall;

    }

    /**
     * Update Image Target Collection
     * Update a target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param updateImageTargetCollectionBody  (required)
     * @return ImageTargetCollectionResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ImageTargetCollectionResponse updateImageTargetCollection(String xVersion, String xToken, String contentType, String tcId, UpdateImageTargetCollectionBody updateImageTargetCollectionBody) throws ApiException {
        ApiResponse<ImageTargetCollectionResponse> localVarResp = updateImageTargetCollectionWithHttpInfo(xVersion, xToken, contentType, tcId, updateImageTargetCollectionBody);
        return localVarResp.getData();
    }

    /**
     * Update Image Target Collection
     * Update a target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param updateImageTargetCollectionBody  (required)
     * @return ApiResponse&lt;ImageTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ImageTargetCollectionResponse> updateImageTargetCollectionWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, UpdateImageTargetCollectionBody updateImageTargetCollectionBody) throws ApiException {
        okhttp3.Call localVarCall = updateImageTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, tcId, updateImageTargetCollectionBody, null);
        Type localVarReturnType = new TypeToken<ImageTargetCollectionResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Update Image Target Collection (asynchronously)
     * Update a target collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Image Target Collection. (required)
     * @param updateImageTargetCollectionBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The updated Image Target Collection. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call updateImageTargetCollectionAsync(String xVersion, String xToken, String contentType, String tcId, UpdateImageTargetCollectionBody updateImageTargetCollectionBody, final ApiCallback<ImageTargetCollectionResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = updateImageTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, tcId, updateImageTargetCollectionBody, _callback);
        Type localVarReturnType = new TypeToken<ImageTargetCollectionResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
