/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.CreateObjectTargetImagesBody;
import org.openapitools.client.model.CreateObjectTargetWTOBody;
import org.openapitools.client.model.ExtendObjectTargetBody;
import org.openapitools.client.model.ObjectTargetJobResponse;
import org.openapitools.client.model.ObjectTargetResponse;
import org.openapitools.client.model.RenameObjectTargetBody;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ObjectTargetApi {
    private ApiClient localVarApiClient;

    public ObjectTargetApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ObjectTargetApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for createObjectTargetFromImages
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetImagesBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createObjectTargetFromImagesCall(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetImagesBody createObjectTargetImagesBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = createObjectTargetImagesBody;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/target/images"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createObjectTargetFromImagesValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetImagesBody createObjectTargetImagesBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling createObjectTargetFromImages(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling createObjectTargetFromImages(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling createObjectTargetFromImages(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling createObjectTargetFromImages(Async)");
        }
        
        // verify the required parameter 'createObjectTargetImagesBody' is set
        if (createObjectTargetImagesBody == null) {
            throw new ApiException("Missing the required parameter 'createObjectTargetImagesBody' when calling createObjectTargetFromImages(Async)");
        }
        

        okhttp3.Call localVarCall = createObjectTargetFromImagesCall(xVersion, xToken, contentType, tcId, createObjectTargetImagesBody, _callback);
        return localVarCall;

    }

    /**
     * Create Object Target from Images
     * Create a new Object Target in an Object Target Collection from at least two Image files.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetImagesBody  (required)
     * @return ObjectTargetJobResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetJobResponse createObjectTargetFromImages(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetImagesBody createObjectTargetImagesBody) throws ApiException {
        ApiResponse<ObjectTargetJobResponse> localVarResp = createObjectTargetFromImagesWithHttpInfo(xVersion, xToken, contentType, tcId, createObjectTargetImagesBody);
        return localVarResp.getData();
    }

    /**
     * Create Object Target from Images
     * Create a new Object Target in an Object Target Collection from at least two Image files.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetImagesBody  (required)
     * @return ApiResponse&lt;ObjectTargetJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetJobResponse> createObjectTargetFromImagesWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetImagesBody createObjectTargetImagesBody) throws ApiException {
        okhttp3.Call localVarCall = createObjectTargetFromImagesValidateBeforeCall(xVersion, xToken, contentType, tcId, createObjectTargetImagesBody, null);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create Object Target from Images (asynchronously)
     * Create a new Object Target in an Object Target Collection from at least two Image files.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetImagesBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createObjectTargetFromImagesAsync(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetImagesBody createObjectTargetImagesBody, final ApiCallback<ObjectTargetJobResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = createObjectTargetFromImagesValidateBeforeCall(xVersion, xToken, contentType, tcId, createObjectTargetImagesBody, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for createObjectTargetFromWTO
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetWTOBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createObjectTargetFromWTOCall(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetWTOBody createObjectTargetWTOBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = createObjectTargetWTOBody;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/target/wto"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createObjectTargetFromWTOValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetWTOBody createObjectTargetWTOBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling createObjectTargetFromWTO(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling createObjectTargetFromWTO(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling createObjectTargetFromWTO(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling createObjectTargetFromWTO(Async)");
        }
        
        // verify the required parameter 'createObjectTargetWTOBody' is set
        if (createObjectTargetWTOBody == null) {
            throw new ApiException("Missing the required parameter 'createObjectTargetWTOBody' when calling createObjectTargetFromWTO(Async)");
        }
        

        okhttp3.Call localVarCall = createObjectTargetFromWTOCall(xVersion, xToken, contentType, tcId, createObjectTargetWTOBody, _callback);
        return localVarCall;

    }

    /**
     * Create Object Target from WTO
     * Create a new Object Target in an Object Target Collection from a WTO file.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetWTOBody  (required)
     * @return ObjectTargetJobResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetJobResponse createObjectTargetFromWTO(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetWTOBody createObjectTargetWTOBody) throws ApiException {
        ApiResponse<ObjectTargetJobResponse> localVarResp = createObjectTargetFromWTOWithHttpInfo(xVersion, xToken, contentType, tcId, createObjectTargetWTOBody);
        return localVarResp.getData();
    }

    /**
     * Create Object Target from WTO
     * Create a new Object Target in an Object Target Collection from a WTO file.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetWTOBody  (required)
     * @return ApiResponse&lt;ObjectTargetJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetJobResponse> createObjectTargetFromWTOWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetWTOBody createObjectTargetWTOBody) throws ApiException {
        okhttp3.Call localVarCall = createObjectTargetFromWTOValidateBeforeCall(xVersion, xToken, contentType, tcId, createObjectTargetWTOBody, null);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create Object Target from WTO (asynchronously)
     * Create a new Object Target in an Object Target Collection from a WTO file.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param createObjectTargetWTOBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createObjectTargetFromWTOAsync(String xVersion, String xToken, String contentType, String tcId, CreateObjectTargetWTOBody createObjectTargetWTOBody, final ApiCallback<ObjectTargetJobResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = createObjectTargetFromWTOValidateBeforeCall(xVersion, xToken, contentType, tcId, createObjectTargetWTOBody, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteObjectTarget
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteObjectTargetCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/target/{targetId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "targetId" + "\\}", localVarApiClient.escapeString(targetId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteObjectTargetValidateBeforeCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling deleteObjectTarget(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling deleteObjectTarget(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling deleteObjectTarget(Async)");
        }
        
        // verify the required parameter 'targetId' is set
        if (targetId == null) {
            throw new ApiException("Missing the required parameter 'targetId' when calling deleteObjectTarget(Async)");
        }
        

        okhttp3.Call localVarCall = deleteObjectTargetCall(xVersion, xToken, tcId, targetId, _callback);
        return localVarCall;

    }

    /**
     * Delete Object Target
     * Delete a particular Object Target from your Object Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public void deleteObjectTarget(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        deleteObjectTargetWithHttpInfo(xVersion, xToken, tcId, targetId);
    }

    /**
     * Delete Object Target
     * Delete a particular Object Target from your Object Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> deleteObjectTargetWithHttpInfo(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        okhttp3.Call localVarCall = deleteObjectTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Delete Object Target (asynchronously)
     * Delete a particular Object Target from your Object Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteObjectTargetAsync(String xVersion, String xToken, String tcId, String targetId, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteObjectTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for extendObjectTarget
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param extendObjectTargetBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; TARGET_NOT_EXTENDABLE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call extendObjectTargetCall(String xVersion, String xToken, String contentType, String tcId, String targetId, ExtendObjectTargetBody extendObjectTargetBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = extendObjectTargetBody;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/target/{targetId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "targetId" + "\\}", localVarApiClient.escapeString(targetId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call extendObjectTargetValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, String targetId, ExtendObjectTargetBody extendObjectTargetBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling extendObjectTarget(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling extendObjectTarget(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling extendObjectTarget(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling extendObjectTarget(Async)");
        }
        
        // verify the required parameter 'targetId' is set
        if (targetId == null) {
            throw new ApiException("Missing the required parameter 'targetId' when calling extendObjectTarget(Async)");
        }
        
        // verify the required parameter 'extendObjectTargetBody' is set
        if (extendObjectTargetBody == null) {
            throw new ApiException("Missing the required parameter 'extendObjectTargetBody' when calling extendObjectTarget(Async)");
        }
        

        okhttp3.Call localVarCall = extendObjectTargetCall(xVersion, xToken, contentType, tcId, targetId, extendObjectTargetBody, _callback);
        return localVarCall;

    }

    /**
     * Extend Object Target
     * Add source images to an existing target.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param extendObjectTargetBody  (required)
     * @return ObjectTargetJobResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; TARGET_NOT_EXTENDABLE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetJobResponse extendObjectTarget(String xVersion, String xToken, String contentType, String tcId, String targetId, ExtendObjectTargetBody extendObjectTargetBody) throws ApiException {
        ApiResponse<ObjectTargetJobResponse> localVarResp = extendObjectTargetWithHttpInfo(xVersion, xToken, contentType, tcId, targetId, extendObjectTargetBody);
        return localVarResp.getData();
    }

    /**
     * Extend Object Target
     * Add source images to an existing target.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param extendObjectTargetBody  (required)
     * @return ApiResponse&lt;ObjectTargetJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; TARGET_NOT_EXTENDABLE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetJobResponse> extendObjectTargetWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, String targetId, ExtendObjectTargetBody extendObjectTargetBody) throws ApiException {
        okhttp3.Call localVarCall = extendObjectTargetValidateBeforeCall(xVersion, xToken, contentType, tcId, targetId, extendObjectTargetBody, null);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Extend Object Target (asynchronously)
     * Add source images to an existing target.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param extendObjectTargetBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; TARGET_NOT_EXTENDABLE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call extendObjectTargetAsync(String xVersion, String xToken, String contentType, String tcId, String targetId, ExtendObjectTargetBody extendObjectTargetBody, final ApiCallback<ObjectTargetJobResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = extendObjectTargetValidateBeforeCall(xVersion, xToken, contentType, tcId, targetId, extendObjectTargetBody, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getObjectTarget
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested Object Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/target/{targetId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "targetId" + "\\}", localVarApiClient.escapeString(targetId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getObjectTargetValidateBeforeCall(String xVersion, String xToken, String tcId, String targetId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getObjectTarget(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getObjectTarget(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getObjectTarget(Async)");
        }
        
        // verify the required parameter 'targetId' is set
        if (targetId == null) {
            throw new ApiException("Missing the required parameter 'targetId' when calling getObjectTarget(Async)");
        }
        

        okhttp3.Call localVarCall = getObjectTargetCall(xVersion, xToken, tcId, targetId, _callback);
        return localVarCall;

    }

    /**
     * Get Object Target
     * Request a specific Object Targets from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @return ObjectTargetResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested Object Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetResponse getObjectTarget(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        ApiResponse<ObjectTargetResponse> localVarResp = getObjectTargetWithHttpInfo(xVersion, xToken, tcId, targetId);
        return localVarResp.getData();
    }

    /**
     * Get Object Target
     * Request a specific Object Targets from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @return ApiResponse&lt;ObjectTargetResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested Object Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetResponse> getObjectTargetWithHttpInfo(String xVersion, String xToken, String tcId, String targetId) throws ApiException {
        okhttp3.Call localVarCall = getObjectTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, null);
        Type localVarReturnType = new TypeToken<ObjectTargetResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get Object Target (asynchronously)
     * Request a specific Object Targets from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The requested Object Target. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetAsync(String xVersion, String xToken, String tcId, String targetId, final ApiCallback<ObjectTargetResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getObjectTargetValidateBeforeCall(xVersion, xToken, tcId, targetId, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getObjectTargetStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetStatusCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/generation/targets/{generationId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "generationId" + "\\}", localVarApiClient.escapeString(generationId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getObjectTargetStatusValidateBeforeCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getObjectTargetStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getObjectTargetStatus(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getObjectTargetStatus(Async)");
        }
        
        // verify the required parameter 'generationId' is set
        if (generationId == null) {
            throw new ApiException("Missing the required parameter 'generationId' when calling getObjectTargetStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getObjectTargetStatusCall(xVersion, xToken, tcId, generationId, _callback);
        return localVarCall;

    }

    /**
     * Status - Object Target Generation Information
     * Retrieves information status about a particular scheduled Object Target creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ObjectTargetJobResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetJobResponse getObjectTargetStatus(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        ApiResponse<ObjectTargetJobResponse> localVarResp = getObjectTargetStatusWithHttpInfo(xVersion, xToken, tcId, generationId);
        return localVarResp.getData();
    }

    /**
     * Status - Object Target Generation Information
     * Retrieves information status about a particular scheduled Object Target creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ApiResponse&lt;ObjectTargetJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetJobResponse> getObjectTargetStatusWithHttpInfo(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        okhttp3.Call localVarCall = getObjectTargetStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, null);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Object Target Generation Information (asynchronously)
     * Retrieves information status about a particular scheduled Object Target creation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetStatusAsync(String xVersion, String xToken, String tcId, String generationId, final ApiCallback<ObjectTargetJobResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getObjectTargetStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getObjectTargets
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Array of all Object Targets. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetsCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/target"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getObjectTargetsValidateBeforeCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getObjectTargets(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getObjectTargets(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getObjectTargets(Async)");
        }
        

        okhttp3.Call localVarCall = getObjectTargetsCall(xVersion, xToken, tcId, _callback);
        return localVarCall;

    }

    /**
     * Get Object Targets
     * Request all Object Targets in a Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @return List&lt;ObjectTargetResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Array of all Object Targets. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public List<ObjectTargetResponse> getObjectTargets(String xVersion, String xToken, String tcId) throws ApiException {
        ApiResponse<List<ObjectTargetResponse>> localVarResp = getObjectTargetsWithHttpInfo(xVersion, xToken, tcId);
        return localVarResp.getData();
    }

    /**
     * Get Object Targets
     * Request all Object Targets in a Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @return ApiResponse&lt;List&lt;ObjectTargetResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Array of all Object Targets. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ObjectTargetResponse>> getObjectTargetsWithHttpInfo(String xVersion, String xToken, String tcId) throws ApiException {
        okhttp3.Call localVarCall = getObjectTargetsValidateBeforeCall(xVersion, xToken, tcId, null);
        Type localVarReturnType = new TypeToken<List<ObjectTargetResponse>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get Object Targets (asynchronously)
     * Request all Object Targets in a Target Collection.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Array of all Object Targets. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetsAsync(String xVersion, String xToken, String tcId, final ApiCallback<List<ObjectTargetResponse>> _callback) throws ApiException {

        okhttp3.Call localVarCall = getObjectTargetsValidateBeforeCall(xVersion, xToken, tcId, _callback);
        Type localVarReturnType = new TypeToken<List<ObjectTargetResponse>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for renameObjectTarget
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param renameObjectTargetBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call renameObjectTargetCall(String xVersion, String xToken, String contentType, String tcId, String targetId, RenameObjectTargetBody renameObjectTargetBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = renameObjectTargetBody;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/target/{targetId}/name"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "targetId" + "\\}", localVarApiClient.escapeString(targetId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call renameObjectTargetValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, String targetId, RenameObjectTargetBody renameObjectTargetBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling renameObjectTarget(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling renameObjectTarget(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling renameObjectTarget(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling renameObjectTarget(Async)");
        }
        
        // verify the required parameter 'targetId' is set
        if (targetId == null) {
            throw new ApiException("Missing the required parameter 'targetId' when calling renameObjectTarget(Async)");
        }
        
        // verify the required parameter 'renameObjectTargetBody' is set
        if (renameObjectTargetBody == null) {
            throw new ApiException("Missing the required parameter 'renameObjectTargetBody' when calling renameObjectTarget(Async)");
        }
        

        okhttp3.Call localVarCall = renameObjectTargetCall(xVersion, xToken, contentType, tcId, targetId, renameObjectTargetBody, _callback);
        return localVarCall;

    }

    /**
     * Rename Object Target
     * Rename an existing target.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param renameObjectTargetBody  (required)
     * @return ObjectTargetJobResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetJobResponse renameObjectTarget(String xVersion, String xToken, String contentType, String tcId, String targetId, RenameObjectTargetBody renameObjectTargetBody) throws ApiException {
        ApiResponse<ObjectTargetJobResponse> localVarResp = renameObjectTargetWithHttpInfo(xVersion, xToken, contentType, tcId, targetId, renameObjectTargetBody);
        return localVarResp.getData();
    }

    /**
     * Rename Object Target
     * Rename an existing target.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param renameObjectTargetBody  (required)
     * @return ApiResponse&lt;ObjectTargetJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetJobResponse> renameObjectTargetWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, String targetId, RenameObjectTargetBody renameObjectTargetBody) throws ApiException {
        okhttp3.Call localVarCall = renameObjectTargetValidateBeforeCall(xVersion, xToken, contentType, tcId, targetId, renameObjectTargetBody, null);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Rename Object Target (asynchronously)
     * Rename an existing target.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param targetId Unique identifier of the Object Target. (required)
     * @param renameObjectTargetBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> The asynchronous job information. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; OBJECT_TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call renameObjectTargetAsync(String xVersion, String xToken, String contentType, String tcId, String targetId, RenameObjectTargetBody renameObjectTargetBody, final ApiCallback<ObjectTargetJobResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = renameObjectTargetValidateBeforeCall(xVersion, xToken, contentType, tcId, targetId, renameObjectTargetBody, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetJobResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
