/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.CreateObjectTargetCollectionBody;
import org.openapitools.client.model.GenerateWTOBody;
import org.openapitools.client.model.ObjectTargetCollectionJobResponse;
import org.openapitools.client.model.ObjectTargetCollectionResponse;
import org.openapitools.client.model.ObjectTargetJobResponse;
import org.openapitools.client.model.UpdateObjectTargetCollectionBody;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ObjectTargetCollectionApi {
    private ApiClient localVarApiClient;

    public ObjectTargetCollectionApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ObjectTargetCollectionApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for createObjectTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createObjectTargetCollectionBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createObjectTargetCollectionCall(String xVersion, String xToken, String contentType, CreateObjectTargetCollectionBody createObjectTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = createObjectTargetCollectionBody;

        // create path and map variables
        String localVarPath = "/objectTargetCollection";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call createObjectTargetCollectionValidateBeforeCall(String xVersion, String xToken, String contentType, CreateObjectTargetCollectionBody createObjectTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling createObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling createObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling createObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'createObjectTargetCollectionBody' is set
        if (createObjectTargetCollectionBody == null) {
            throw new ApiException("Missing the required parameter 'createObjectTargetCollectionBody' when calling createObjectTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = createObjectTargetCollectionCall(xVersion, xToken, contentType, createObjectTargetCollectionBody, _callback);
        return localVarCall;

    }

    /**
     * Create Object Target Collection
     * Create a new Object Target Collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createObjectTargetCollectionBody  (required)
     * @return ObjectTargetCollectionResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetCollectionResponse createObjectTargetCollection(String xVersion, String xToken, String contentType, CreateObjectTargetCollectionBody createObjectTargetCollectionBody) throws ApiException {
        ApiResponse<ObjectTargetCollectionResponse> localVarResp = createObjectTargetCollectionWithHttpInfo(xVersion, xToken, contentType, createObjectTargetCollectionBody);
        return localVarResp.getData();
    }

    /**
     * Create Object Target Collection
     * Create a new Object Target Collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createObjectTargetCollectionBody  (required)
     * @return ApiResponse&lt;ObjectTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetCollectionResponse> createObjectTargetCollectionWithHttpInfo(String xVersion, String xToken, String contentType, CreateObjectTargetCollectionBody createObjectTargetCollectionBody) throws ApiException {
        okhttp3.Call localVarCall = createObjectTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, createObjectTargetCollectionBody, null);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Create Object Target Collection (asynchronously)
     * Create a new Object Target Collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param createObjectTargetCollectionBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> TARGET_COLLECTION_NOT_FOUND&lt;br/&gt; TARGET_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call createObjectTargetCollectionAsync(String xVersion, String xToken, String contentType, CreateObjectTargetCollectionBody createObjectTargetCollectionBody, final ApiCallback<ObjectTargetCollectionResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = createObjectTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, createObjectTargetCollectionBody, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for deleteObjectTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteObjectTargetCollectionCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "DELETE", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call deleteObjectTargetCollectionValidateBeforeCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling deleteObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling deleteObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling deleteObjectTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = deleteObjectTargetCollectionCall(xVersion, xToken, tcId, _callback);
        return localVarCall;

    }

    /**
     * Delete Object Target Collection
     * Delete a Object Target Collection and all its Object Targets.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public void deleteObjectTargetCollection(String xVersion, String xToken, String tcId) throws ApiException {
        deleteObjectTargetCollectionWithHttpInfo(xVersion, xToken, tcId);
    }

    /**
     * Delete Object Target Collection
     * Delete a Object Target Collection and all its Object Targets.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<Void> deleteObjectTargetCollectionWithHttpInfo(String xVersion, String xToken, String tcId) throws ApiException {
        okhttp3.Call localVarCall = deleteObjectTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, null);
        return localVarApiClient.execute(localVarCall);
    }

    /**
     * Delete Object Target Collection (asynchronously)
     * Delete a Object Target Collection and all its Object Targets.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 204 </td><td> Successful operation - Empty response body. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call deleteObjectTargetCollectionAsync(String xVersion, String xToken, String tcId, final ApiCallback<Void> _callback) throws ApiException {

        okhttp3.Call localVarCall = deleteObjectTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, _callback);
        localVarApiClient.executeAsync(localVarCall, _callback);
        return localVarCall;
    }
    /**
     * Build call for generateWTO
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generateWTOBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Returns job status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> OBJECT_TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateWTOCall(String xVersion, String xToken, String contentType, String tcId, GenerateWTOBody generateWTOBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = generateWTOBody;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/generation/wto"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call generateWTOValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, GenerateWTOBody generateWTOBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling generateWTO(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling generateWTO(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling generateWTO(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling generateWTO(Async)");
        }
        
        // verify the required parameter 'generateWTOBody' is set
        if (generateWTOBody == null) {
            throw new ApiException("Missing the required parameter 'generateWTOBody' when calling generateWTO(Async)");
        }
        

        okhttp3.Call localVarCall = generateWTOCall(xVersion, xToken, contentType, tcId, generateWTOBody, _callback);
        return localVarCall;

    }

    /**
     * Generate WTO
     * Generate a WTO file containing the Object Target Collection and all its Object Targets.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generateWTOBody  (required)
     * @return ObjectTargetCollectionJobResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Returns job status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> OBJECT_TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetCollectionJobResponse generateWTO(String xVersion, String xToken, String contentType, String tcId, GenerateWTOBody generateWTOBody) throws ApiException {
        ApiResponse<ObjectTargetCollectionJobResponse> localVarResp = generateWTOWithHttpInfo(xVersion, xToken, contentType, tcId, generateWTOBody);
        return localVarResp.getData();
    }

    /**
     * Generate WTO
     * Generate a WTO file containing the Object Target Collection and all its Object Targets.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generateWTOBody  (required)
     * @return ApiResponse&lt;ObjectTargetCollectionJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Returns job status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> OBJECT_TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetCollectionJobResponse> generateWTOWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, GenerateWTOBody generateWTOBody) throws ApiException {
        okhttp3.Call localVarCall = generateWTOValidateBeforeCall(xVersion, xToken, contentType, tcId, generateWTOBody, null);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionJobResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Generate WTO (asynchronously)
     * Generate a WTO file containing the Object Target Collection and all its Object Targets.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generateWTOBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 202 </td><td> Returns job status. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 412 </td><td> OBJECT_TARGET_COLLECTION_IS_EMPTY  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call generateWTOAsync(String xVersion, String xToken, String contentType, String tcId, GenerateWTOBody generateWTOBody, final ApiCallback<ObjectTargetCollectionJobResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = generateWTOValidateBeforeCall(xVersion, xToken, contentType, tcId, generateWTOBody, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionJobResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getObjectTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetCollectionCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getObjectTargetCollectionValidateBeforeCall(String xVersion, String xToken, String tcId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getObjectTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = getObjectTargetCollectionCall(xVersion, xToken, tcId, _callback);
        return localVarCall;

    }

    /**
     * Get Object Target Collection
     * Request a particular Object Target Collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @return ObjectTargetCollectionResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetCollectionResponse getObjectTargetCollection(String xVersion, String xToken, String tcId) throws ApiException {
        ApiResponse<ObjectTargetCollectionResponse> localVarResp = getObjectTargetCollectionWithHttpInfo(xVersion, xToken, tcId);
        return localVarResp.getData();
    }

    /**
     * Get Object Target Collection
     * Request a particular Object Target Collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @return ApiResponse&lt;ObjectTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetCollectionResponse> getObjectTargetCollectionWithHttpInfo(String xVersion, String xToken, String tcId) throws ApiException {
        okhttp3.Call localVarCall = getObjectTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, null);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get Object Target Collection (asynchronously)
     * Request a particular Object Target Collection from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetCollectionAsync(String xVersion, String xToken, String tcId, final ApiCallback<ObjectTargetCollectionResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getObjectTargetCollectionValidateBeforeCall(xVersion, xToken, tcId, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getObjectTargetCollectionStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param skip Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 (optional)
     * @param source filter the jobs by source. Available values (api, studio). Default value: api (optional)
     * @param type filter the jobs by type. (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns a list of the asynchronous jobs. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetCollectionStatusCall(String xVersion, String xToken, String tcId, Integer skip, Integer limit, String source, String type, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/jobs"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (skip != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("skip", skip));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (source != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("source", source));
        }

        if (type != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("type", type));
        }

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getObjectTargetCollectionStatusValidateBeforeCall(String xVersion, String xToken, String tcId, Integer skip, Integer limit, String source, String type, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getObjectTargetCollectionStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getObjectTargetCollectionStatus(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getObjectTargetCollectionStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getObjectTargetCollectionStatusCall(xVersion, xToken, tcId, skip, limit, source, type, _callback);
        return localVarCall;

    }

    /**
     * Status - Get Object Target Collection jobs
     * Retrieves a list of asynchronous jobs sorted by creation date.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param skip Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 (optional)
     * @param source filter the jobs by source. Available values (api, studio). Default value: api (optional)
     * @param type filter the jobs by type. (optional)
     * @return List&lt;ObjectTargetJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns a list of the asynchronous jobs. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public List<ObjectTargetJobResponse> getObjectTargetCollectionStatus(String xVersion, String xToken, String tcId, Integer skip, Integer limit, String source, String type) throws ApiException {
        ApiResponse<List<ObjectTargetJobResponse>> localVarResp = getObjectTargetCollectionStatusWithHttpInfo(xVersion, xToken, tcId, skip, limit, source, type);
        return localVarResp.getData();
    }

    /**
     * Status - Get Object Target Collection jobs
     * Retrieves a list of asynchronous jobs sorted by creation date.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param skip Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 (optional)
     * @param source filter the jobs by source. Available values (api, studio). Default value: api (optional)
     * @param type filter the jobs by type. (optional)
     * @return ApiResponse&lt;List&lt;ObjectTargetJobResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns a list of the asynchronous jobs. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ObjectTargetJobResponse>> getObjectTargetCollectionStatusWithHttpInfo(String xVersion, String xToken, String tcId, Integer skip, Integer limit, String source, String type) throws ApiException {
        okhttp3.Call localVarCall = getObjectTargetCollectionStatusValidateBeforeCall(xVersion, xToken, tcId, skip, limit, source, type, null);
        Type localVarReturnType = new TypeToken<List<ObjectTargetJobResponse>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Get Object Target Collection jobs (asynchronously)
     * Retrieves a list of asynchronous jobs sorted by creation date.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param skip Set 0 to start with first collection, set e.g. to 2 to skip first 2 collections. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 20] per page. Default value: 10 (optional)
     * @param source filter the jobs by source. Available values (api, studio). Default value: api (optional)
     * @param type filter the jobs by type. (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns a list of the asynchronous jobs. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetCollectionStatusAsync(String xVersion, String xToken, String tcId, Integer skip, Integer limit, String source, String type, final ApiCallback<List<ObjectTargetJobResponse>> _callback) throws ApiException {

        okhttp3.Call localVarCall = getObjectTargetCollectionStatusValidateBeforeCall(xVersion, xToken, tcId, skip, limit, source, type, _callback);
        Type localVarReturnType = new TypeToken<List<ObjectTargetJobResponse>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getObjectTargetCollections
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful response </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> FEATURE_NOT_SUPPORTED  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetCollectionsCall(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (skip != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("skip", skip));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getObjectTargetCollectionsValidateBeforeCall(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getObjectTargetCollections(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getObjectTargetCollections(Async)");
        }
        

        okhttp3.Call localVarCall = getObjectTargetCollectionsCall(xVersion, xToken, skip, limit, _callback);
        return localVarCall;

    }

    /**
     * Get all Object Target Collections
     * Request all Object Target Collections from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @return List&lt;ObjectTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful response </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> FEATURE_NOT_SUPPORTED  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public List<ObjectTargetCollectionResponse> getObjectTargetCollections(String xVersion, String xToken, Integer skip, Integer limit) throws ApiException {
        ApiResponse<List<ObjectTargetCollectionResponse>> localVarResp = getObjectTargetCollectionsWithHttpInfo(xVersion, xToken, skip, limit);
        return localVarResp.getData();
    }

    /**
     * Get all Object Target Collections
     * Request all Object Target Collections from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @return ApiResponse&lt;List&lt;ObjectTargetCollectionResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful response </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> FEATURE_NOT_SUPPORTED  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<ObjectTargetCollectionResponse>> getObjectTargetCollectionsWithHttpInfo(String xVersion, String xToken, Integer skip, Integer limit) throws ApiException {
        okhttp3.Call localVarCall = getObjectTargetCollectionsValidateBeforeCall(xVersion, xToken, skip, limit, null);
        Type localVarReturnType = new TypeToken<List<ObjectTargetCollectionResponse>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get all Object Target Collections (asynchronously)
     * Request all Object Target Collections from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful response </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> FEATURE_NOT_SUPPORTED  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getObjectTargetCollectionsAsync(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback<List<ObjectTargetCollectionResponse>> _callback) throws ApiException {

        okhttp3.Call localVarCall = getObjectTargetCollectionsValidateBeforeCall(xVersion, xToken, skip, limit, _callback);
        Type localVarReturnType = new TypeToken<List<ObjectTargetCollectionResponse>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for getWTOStatus
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns status of the asynchronous job. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getWTOStatusCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}/generation/wto/{generationId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()))
            .replaceAll("\\{" + "generationId" + "\\}", localVarApiClient.escapeString(generationId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getWTOStatusValidateBeforeCall(String xVersion, String xToken, String tcId, String generationId, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getWTOStatus(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getWTOStatus(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling getWTOStatus(Async)");
        }
        
        // verify the required parameter 'generationId' is set
        if (generationId == null) {
            throw new ApiException("Missing the required parameter 'generationId' when calling getWTOStatus(Async)");
        }
        

        okhttp3.Call localVarCall = getWTOStatusCall(xVersion, xToken, tcId, generationId, _callback);
        return localVarCall;

    }

    /**
     * Status - Generate WTO
     * Retrieves information status about a particular scheduled wto generation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ObjectTargetCollectionJobResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns status of the asynchronous job. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetCollectionJobResponse getWTOStatus(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        ApiResponse<ObjectTargetCollectionJobResponse> localVarResp = getWTOStatusWithHttpInfo(xVersion, xToken, tcId, generationId);
        return localVarResp.getData();
    }

    /**
     * Status - Generate WTO
     * Retrieves information status about a particular scheduled wto generation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @return ApiResponse&lt;ObjectTargetCollectionJobResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns status of the asynchronous job. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetCollectionJobResponse> getWTOStatusWithHttpInfo(String xVersion, String xToken, String tcId, String generationId) throws ApiException {
        okhttp3.Call localVarCall = getWTOStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, null);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionJobResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Status - Generate WTO (asynchronously)
     * Retrieves information status about a particular scheduled wto generation.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param generationId Unique identifier of the asynchronous job created by a generation endpoint. (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> Returns status of the asynchronous job. </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> GENERATION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getWTOStatusAsync(String xVersion, String xToken, String tcId, String generationId, final ApiCallback<ObjectTargetCollectionJobResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = getWTOStatusValidateBeforeCall(xVersion, xToken, tcId, generationId, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionJobResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
    /**
     * Build call for updateObjectTargetCollection
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param updateObjectTargetCollectionBody  (required)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call updateObjectTargetCollectionCall(String xVersion, String xToken, String contentType, String tcId, UpdateObjectTargetCollectionBody updateObjectTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = updateObjectTargetCollectionBody;

        // create path and map variables
        String localVarPath = "/objectTargetCollection/{tcId}"
            .replaceAll("\\{" + "tcId" + "\\}", localVarApiClient.escapeString(tcId.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        if (contentType != null) {
            localVarHeaderParams.put("Content-Type", localVarApiClient.parameterToString(contentType));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call updateObjectTargetCollectionValidateBeforeCall(String xVersion, String xToken, String contentType, String tcId, UpdateObjectTargetCollectionBody updateObjectTargetCollectionBody, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling updateObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling updateObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'contentType' is set
        if (contentType == null) {
            throw new ApiException("Missing the required parameter 'contentType' when calling updateObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'tcId' is set
        if (tcId == null) {
            throw new ApiException("Missing the required parameter 'tcId' when calling updateObjectTargetCollection(Async)");
        }
        
        // verify the required parameter 'updateObjectTargetCollectionBody' is set
        if (updateObjectTargetCollectionBody == null) {
            throw new ApiException("Missing the required parameter 'updateObjectTargetCollectionBody' when calling updateObjectTargetCollection(Async)");
        }
        

        okhttp3.Call localVarCall = updateObjectTargetCollectionCall(xVersion, xToken, contentType, tcId, updateObjectTargetCollectionBody, _callback);
        return localVarCall;

    }

    /**
     * Update Object Target Collection
     * Updates an existing Object Target Collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param updateObjectTargetCollectionBody  (required)
     * @return ObjectTargetCollectionResponse
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ObjectTargetCollectionResponse updateObjectTargetCollection(String xVersion, String xToken, String contentType, String tcId, UpdateObjectTargetCollectionBody updateObjectTargetCollectionBody) throws ApiException {
        ApiResponse<ObjectTargetCollectionResponse> localVarResp = updateObjectTargetCollectionWithHttpInfo(xVersion, xToken, contentType, tcId, updateObjectTargetCollectionBody);
        return localVarResp.getData();
    }

    /**
     * Update Object Target Collection
     * Updates an existing Object Target Collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param updateObjectTargetCollectionBody  (required)
     * @return ApiResponse&lt;ObjectTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<ObjectTargetCollectionResponse> updateObjectTargetCollectionWithHttpInfo(String xVersion, String xToken, String contentType, String tcId, UpdateObjectTargetCollectionBody updateObjectTargetCollectionBody) throws ApiException {
        okhttp3.Call localVarCall = updateObjectTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, tcId, updateObjectTargetCollectionBody, null);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionResponse>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Update Object Target Collection (asynchronously)
     * Updates an existing Object Target Collection in your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param contentType The Content Type of the body. Must be set to application/json. (required)
     * @param tcId Unique identifier of the Object Target Collection. (required)
     * @param updateObjectTargetCollectionBody  (required)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> successful operation </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_PROPERTY&lt;br/&gt; BODY_CONTENT_TOO_LARGE  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 404 </td><td> OBJECT_TARGET_COLLECTION_NOT_FOUND  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call updateObjectTargetCollectionAsync(String xVersion, String xToken, String contentType, String tcId, UpdateObjectTargetCollectionBody updateObjectTargetCollectionBody, final ApiCallback<ObjectTargetCollectionResponse> _callback) throws ApiException {

        okhttp3.Call localVarCall = updateObjectTargetCollectionValidateBeforeCall(xVersion, xToken, contentType, tcId, updateObjectTargetCollectionBody, _callback);
        Type localVarReturnType = new TypeToken<ObjectTargetCollectionResponse>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
