/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiCallback;
import org.openapitools.client.ApiClient;
import org.openapitools.client.ApiException;
import org.openapitools.client.ApiResponse;
import org.openapitools.client.Configuration;
import org.openapitools.client.Pair;
import org.openapitools.client.ProgressRequestBody;
import org.openapitools.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import org.openapitools.client.model.AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ProjectApi {
    private ApiClient localVarApiClient;

    public ProjectApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ProjectApi(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return localVarApiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.localVarApiClient = apiClient;
    }

    /**
     * Build call for getProjects
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @param _callback Callback for upload/download progress
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Projects in your account </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getProjectsCall(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback _callback) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/projects";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        Map<String, String> localVarCookieParams = new HashMap<String, String>();
        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        if (skip != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("skip", skip));
        }

        if (limit != null) {
            localVarQueryParams.addAll(localVarApiClient.parameterToPair("limit", limit));
        }

        if (xVersion != null) {
            localVarHeaderParams.put("X-Version", localVarApiClient.parameterToString(xVersion));
        }

        if (xToken != null) {
            localVarHeaderParams.put("X-Token", localVarApiClient.parameterToString(xToken));
        }

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = localVarApiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) {
            localVarHeaderParams.put("Accept", localVarAccept);
        }

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = localVarApiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        String[] localVarAuthNames = new String[] {  };
        return localVarApiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarCookieParams, localVarFormParams, localVarAuthNames, _callback);
    }

    @SuppressWarnings("rawtypes")
    private okhttp3.Call getProjectsValidateBeforeCall(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback _callback) throws ApiException {
        
        // verify the required parameter 'xVersion' is set
        if (xVersion == null) {
            throw new ApiException("Missing the required parameter 'xVersion' when calling getProjects(Async)");
        }
        
        // verify the required parameter 'xToken' is set
        if (xToken == null) {
            throw new ApiException("Missing the required parameter 'xToken' when calling getProjects(Async)");
        }
        

        okhttp3.Call localVarCall = getProjectsCall(xVersion, xToken, skip, limit, _callback);
        return localVarCall;

    }

    /**
     * Get all projects
     * Request all projects from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @return List&lt;AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Projects in your account </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public List<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse> getProjects(String xVersion, String xToken, Integer skip, Integer limit) throws ApiException {
        ApiResponse<List<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>> localVarResp = getProjectsWithHttpInfo(xVersion, xToken, skip, limit);
        return localVarResp.getData();
    }

    /**
     * Get all projects
     * Request all projects from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @return ApiResponse&lt;List&lt;AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Projects in your account </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public ApiResponse<List<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>> getProjectsWithHttpInfo(String xVersion, String xToken, Integer skip, Integer limit) throws ApiException {
        okhttp3.Call localVarCall = getProjectsValidateBeforeCall(xVersion, xToken, skip, limit, null);
        Type localVarReturnType = new TypeToken<List<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>>(){}.getType();
        return localVarApiClient.execute(localVarCall, localVarReturnType);
    }

    /**
     * Get all projects (asynchronously)
     * Request all projects from your account.
     * @param xVersion The version of the API to be used. Must be set to 3. (required)
     * @param xToken Your Manager Token. (required)
     * @param skip Set 0 to start with first entry, set e.g. to 2 to skip first 2 entries. Default value: 0 (optional)
     * @param limit Use positive value to define the amount of entries to return [1, 1000] per page. Default value: 1000 (optional)
     * @param _callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     * @http.response.details
     <table summary="Response Details" border="1">
        <tr><td> Status Code </td><td> Description </td><td> Response Headers </td></tr>
        <tr><td> 200 </td><td> The Array of Projects in your account </td><td>  -  </td></tr>
        <tr><td> 400 </td><td> HEADER_PROPERTY_MISSING&lt;br/&gt; HEADER_PROPERTY_INVALID&lt;br/&gt; INVALID_QUERY_PARAMETER  </td><td>  -  </td></tr>
        <tr><td> 401 </td><td> INVALID_TOKEN  </td><td>  -  </td></tr>
        <tr><td> 500 </td><td> INTERNAL_SERVER_ERROR  </td><td>  -  </td></tr>
     </table>
     */
    public okhttp3.Call getProjectsAsync(String xVersion, String xToken, Integer skip, Integer limit, final ApiCallback<List<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>> _callback) throws ApiException {

        okhttp3.Call localVarCall = getProjectsValidateBeforeCall(xVersion, xToken, skip, limit, _callback);
        Type localVarReturnType = new TypeToken<List<AnyOfImageTargetCollectionResponseObjectTargetCollectionResponse>>(){}.getType();
        localVarApiClient.executeAsync(localVarCall, localVarReturnType, _callback);
        return localVarCall;
    }
}
