/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.CreateImageTargetsResponseInputParamsTargets;

/**
 * Object containing job relevant parameters.
 */
@ApiModel(description = "Object containing job relevant parameters.")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class CreateImageTargetsResponseInputParams {
  public static final String SERIALIZED_NAME_TC_ID = "tcId";
  @SerializedName(SERIALIZED_NAME_TC_ID)
  private String tcId;

  public static final String SERIALIZED_NAME_TARGETS = "targets";
  @SerializedName(SERIALIZED_NAME_TARGETS)
  private List<CreateImageTargetsResponseInputParamsTargets> targets = null;

  public static final String SERIALIZED_NAME_USER_ID = "userId";
  @SerializedName(SERIALIZED_NAME_USER_ID)
  private String userId;


  public CreateImageTargetsResponseInputParams tcId(String tcId) {
    
    this.tcId = tcId;
    return this;
  }

   /**
   * Unique identifier of the Target Collection.
   * @return tcId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "tcId00000000000000000001", value = "Unique identifier of the Target Collection.")

  public String getTcId() {
    return tcId;
  }


  public void setTcId(String tcId) {
    this.tcId = tcId;
  }


  public CreateImageTargetsResponseInputParams targets(List<CreateImageTargetsResponseInputParamsTargets> targets) {
    
    this.targets = targets;
    return this;
  }

  public CreateImageTargetsResponseInputParams addTargetsItem(CreateImageTargetsResponseInputParamsTargets targetsItem) {
    if (this.targets == null) {
      this.targets = new ArrayList<CreateImageTargetsResponseInputParamsTargets>();
    }
    this.targets.add(targetsItem);
    return this;
  }

   /**
   * List of Image Targets.
   * @return targets
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "List of Image Targets.")

  public List<CreateImageTargetsResponseInputParamsTargets> getTargets() {
    return targets;
  }


  public void setTargets(List<CreateImageTargetsResponseInputParamsTargets> targets) {
    this.targets = targets;
  }


  public CreateImageTargetsResponseInputParams userId(String userId) {
    
    this.userId = userId;
    return this;
  }

   /**
   * Unique identifier of the User.
   * @return userId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "user00000000000000000001", value = "Unique identifier of the User.")

  public String getUserId() {
    return userId;
  }


  public void setUserId(String userId) {
    this.userId = userId;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateImageTargetsResponseInputParams createImageTargetsResponseInputParams = (CreateImageTargetsResponseInputParams) o;
    return Objects.equals(this.tcId, createImageTargetsResponseInputParams.tcId) &&
        Objects.equals(this.targets, createImageTargetsResponseInputParams.targets) &&
        Objects.equals(this.userId, createImageTargetsResponseInputParams.userId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(tcId, targets, userId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateImageTargetsResponseInputParams {\n");
    sb.append("    tcId: ").append(toIndentedString(tcId)).append("\n");
    sb.append("    targets: ").append(toIndentedString(targets)).append("\n");
    sb.append("    userId: ").append(toIndentedString(userId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

