/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import org.openapitools.client.model.GenerateHeatmapResponseInputParams;
import org.openapitools.client.model.GenerateHeatmapStatusResponsePayload;

/**
 * GenerateHeatmapStatusResponse
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class GenerateHeatmapStatusResponse {
  public static final String SERIALIZED_NAME_INPUT_PARAMS = "inputParams";
  @SerializedName(SERIALIZED_NAME_INPUT_PARAMS)
  private GenerateHeatmapResponseInputParams inputParams;

  public static final String SERIALIZED_NAME_PAYLOAD = "payload";
  @SerializedName(SERIALIZED_NAME_PAYLOAD)
  private GenerateHeatmapStatusResponsePayload payload;

  public static final String SERIALIZED_NAME_CREATION_DATE = "creationDate";
  @SerializedName(SERIALIZED_NAME_CREATION_DATE)
  private BigDecimal creationDate;

  public static final String SERIALIZED_NAME_ESTIMATED_START = "estimatedStart";
  @SerializedName(SERIALIZED_NAME_ESTIMATED_START)
  private BigDecimal estimatedStart;

  public static final String SERIALIZED_NAME_ESTIMATED_END = "estimatedEnd";
  @SerializedName(SERIALIZED_NAME_ESTIMATED_END)
  private BigDecimal estimatedEnd;

  public static final String SERIALIZED_NAME_ESTIMATED_LATENCY = "estimatedLatency";
  @SerializedName(SERIALIZED_NAME_ESTIMATED_LATENCY)
  private BigDecimal estimatedLatency;

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private String status;

  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;


  public GenerateHeatmapStatusResponse inputParams(GenerateHeatmapResponseInputParams inputParams) {
    
    this.inputParams = inputParams;
    return this;
  }

   /**
   * Get inputParams
   * @return inputParams
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public GenerateHeatmapResponseInputParams getInputParams() {
    return inputParams;
  }


  public void setInputParams(GenerateHeatmapResponseInputParams inputParams) {
    this.inputParams = inputParams;
  }


  public GenerateHeatmapStatusResponse payload(GenerateHeatmapStatusResponsePayload payload) {
    
    this.payload = payload;
    return this;
  }

   /**
   * Get payload
   * @return payload
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public GenerateHeatmapStatusResponsePayload getPayload() {
    return payload;
  }


  public void setPayload(GenerateHeatmapStatusResponsePayload payload) {
    this.payload = payload;
  }


  public GenerateHeatmapStatusResponse creationDate(BigDecimal creationDate) {
    
    this.creationDate = creationDate;
    return this;
  }

   /**
   * Timestamp of the job creation.
   * @return creationDate
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069526660", value = "Timestamp of the job creation.")

  public BigDecimal getCreationDate() {
    return creationDate;
  }


  public void setCreationDate(BigDecimal creationDate) {
    this.creationDate = creationDate;
  }


  public GenerateHeatmapStatusResponse estimatedStart(BigDecimal estimatedStart) {
    
    this.estimatedStart = estimatedStart;
    return this;
  }

   /**
   * Estimation of when the job will start processing.
   * @return estimatedStart
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069528660", value = "Estimation of when the job will start processing.")

  public BigDecimal getEstimatedStart() {
    return estimatedStart;
  }


  public void setEstimatedStart(BigDecimal estimatedStart) {
    this.estimatedStart = estimatedStart;
  }


  public GenerateHeatmapStatusResponse estimatedEnd(BigDecimal estimatedEnd) {
    
    this.estimatedEnd = estimatedEnd;
    return this;
  }

   /**
   * Estimation of when the job will approximately be finished.
   * @return estimatedEnd
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069533660", value = "Estimation of when the job will approximately be finished.")

  public BigDecimal getEstimatedEnd() {
    return estimatedEnd;
  }


  public void setEstimatedEnd(BigDecimal estimatedEnd) {
    this.estimatedEnd = estimatedEnd;
  }


  public GenerateHeatmapStatusResponse estimatedLatency(BigDecimal estimatedLatency) {
    
    this.estimatedLatency = estimatedLatency;
    return this;
  }

   /**
   * Recommendation of when to first poll the corresponding status endpoint in milliseconds.
   * @return estimatedLatency
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "5000", value = "Recommendation of when to first poll the corresponding status endpoint in milliseconds.")

  public BigDecimal getEstimatedLatency() {
    return estimatedLatency;
  }


  public void setEstimatedLatency(BigDecimal estimatedLatency) {
    this.estimatedLatency = estimatedLatency;
  }


  public GenerateHeatmapStatusResponse status(String status) {
    
    this.status = status;
    return this;
  }

   /**
   * The status of the asynchronous job.
   * @return status
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "SCHEDULED | RUNNING | FAILED | COMPLETED", value = "The status of the asynchronous job.")

  public String getStatus() {
    return status;
  }


  public void setStatus(String status) {
    this.status = status;
  }


  public GenerateHeatmapStatusResponse id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * The asynchronous job id.
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "BykyFRRZw", value = "The asynchronous job id.")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GenerateHeatmapStatusResponse generateHeatmapStatusResponse = (GenerateHeatmapStatusResponse) o;
    return Objects.equals(this.inputParams, generateHeatmapStatusResponse.inputParams) &&
        Objects.equals(this.payload, generateHeatmapStatusResponse.payload) &&
        Objects.equals(this.creationDate, generateHeatmapStatusResponse.creationDate) &&
        Objects.equals(this.estimatedStart, generateHeatmapStatusResponse.estimatedStart) &&
        Objects.equals(this.estimatedEnd, generateHeatmapStatusResponse.estimatedEnd) &&
        Objects.equals(this.estimatedLatency, generateHeatmapStatusResponse.estimatedLatency) &&
        Objects.equals(this.status, generateHeatmapStatusResponse.status) &&
        Objects.equals(this.id, generateHeatmapStatusResponse.id);
  }

  @Override
  public int hashCode() {
    return Objects.hash(inputParams, payload, creationDate, estimatedStart, estimatedEnd, estimatedLatency, status, id);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GenerateHeatmapStatusResponse {\n");
    sb.append("    inputParams: ").append(toIndentedString(inputParams)).append("\n");
    sb.append("    payload: ").append(toIndentedString(payload)).append("\n");
    sb.append("    creationDate: ").append(toIndentedString(creationDate)).append("\n");
    sb.append("    estimatedStart: ").append(toIndentedString(estimatedStart)).append("\n");
    sb.append("    estimatedEnd: ").append(toIndentedString(estimatedEnd)).append("\n");
    sb.append("    estimatedLatency: ").append(toIndentedString(estimatedLatency)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

