/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * GenerateWTCStatusResponse
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class GenerateWTCStatusResponse {
  public static final String SERIALIZED_NAME_PAYLOAD = "payload";
  @SerializedName(SERIALIZED_NAME_PAYLOAD)
  private Object payload;

  public static final String SERIALIZED_NAME_ESTIMATED_START = "estimatedStart";
  @SerializedName(SERIALIZED_NAME_ESTIMATED_START)
  private BigDecimal estimatedStart;

  public static final String SERIALIZED_NAME_ESTIMATED_END = "estimatedEnd";
  @SerializedName(SERIALIZED_NAME_ESTIMATED_END)
  private BigDecimal estimatedEnd;

  public static final String SERIALIZED_NAME_STATUS = "status";
  @SerializedName(SERIALIZED_NAME_STATUS)
  private String status;

  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_E_MAIL = "eMail";
  @SerializedName(SERIALIZED_NAME_E_MAIL)
  private String eMail;

  public static final String SERIALIZED_NAME_GENERATION_ID = "generationId";
  @SerializedName(SERIALIZED_NAME_GENERATION_ID)
  private String generationId;

  public static final String SERIALIZED_NAME_CREATED = "created";
  @SerializedName(SERIALIZED_NAME_CREATED)
  private BigDecimal created;

  public static final String SERIALIZED_NAME_SDK_VERSION = "sdkVersion";
  @SerializedName(SERIALIZED_NAME_SDK_VERSION)
  private String sdkVersion;


  public GenerateWTCStatusResponse payload(Object payload) {
    
    this.payload = payload;
    return this;
  }

   /**
   * Object containing job relevant results.
   * @return payload
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Object containing job relevant results.")

  public Object getPayload() {
    return payload;
  }


  public void setPayload(Object payload) {
    this.payload = payload;
  }


  public GenerateWTCStatusResponse estimatedStart(BigDecimal estimatedStart) {
    
    this.estimatedStart = estimatedStart;
    return this;
  }

   /**
   * Estimation of when the job will start processing.
   * @return estimatedStart
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069528660", value = "Estimation of when the job will start processing.")

  public BigDecimal getEstimatedStart() {
    return estimatedStart;
  }


  public void setEstimatedStart(BigDecimal estimatedStart) {
    this.estimatedStart = estimatedStart;
  }


  public GenerateWTCStatusResponse estimatedEnd(BigDecimal estimatedEnd) {
    
    this.estimatedEnd = estimatedEnd;
    return this;
  }

   /**
   * Estimation of when the job will approximately be finished.
   * @return estimatedEnd
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069533660", value = "Estimation of when the job will approximately be finished.")

  public BigDecimal getEstimatedEnd() {
    return estimatedEnd;
  }


  public void setEstimatedEnd(BigDecimal estimatedEnd) {
    this.estimatedEnd = estimatedEnd;
  }


  public GenerateWTCStatusResponse status(String status) {
    
    this.status = status;
    return this;
  }

   /**
   * The status of the asynchronous job.
   * @return status
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "SCHEDULED | RUNNING | FAILED | COMPLETED", value = "The status of the asynchronous job.")

  public String getStatus() {
    return status;
  }


  public void setStatus(String status) {
    this.status = status;
  }


  public GenerateWTCStatusResponse id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Unique identifier of the Target Collection.
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "tcId00000000000000000001", value = "Unique identifier of the Target Collection.")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public GenerateWTCStatusResponse eMail(String eMail) {
    
    this.eMail = eMail;
    return this;
  }

   /**
   * The e-mail address, the notification is sent after the generation of the resource is finished.
   * @return eMail
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "noreply@wikitude.com", value = "The e-mail address, the notification is sent after the generation of the resource is finished.")

  public String geteMail() {
    return eMail;
  }


  public void seteMail(String eMail) {
    this.eMail = eMail;
  }


  public GenerateWTCStatusResponse generationId(String generationId) {
    
    this.generationId = generationId;
    return this;
  }

   /**
   * The asynchronous job id.
   * @return generationId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "BykyFRRZw", value = "The asynchronous job id.")

  public String getGenerationId() {
    return generationId;
  }


  public void setGenerationId(String generationId) {
    this.generationId = generationId;
  }


  public GenerateWTCStatusResponse created(BigDecimal created) {
    
    this.created = created;
    return this;
  }

   /**
   * Timestamp of the job creation.
   * @return created
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069526660", value = "Timestamp of the job creation.")

  public BigDecimal getCreated() {
    return created;
  }


  public void setCreated(BigDecimal created) {
    this.created = created;
  }


  public GenerateWTCStatusResponse sdkVersion(String sdkVersion) {
    
    this.sdkVersion = sdkVersion;
    return this;
  }

   /**
   * Version of the Wikitude SDK the WTC resource was generated for.
   * @return sdkVersion
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "8.5", value = "Version of the Wikitude SDK the WTC resource was generated for.")

  public String getSdkVersion() {
    return sdkVersion;
  }


  public void setSdkVersion(String sdkVersion) {
    this.sdkVersion = sdkVersion;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GenerateWTCStatusResponse generateWTCStatusResponse = (GenerateWTCStatusResponse) o;
    return Objects.equals(this.payload, generateWTCStatusResponse.payload) &&
        Objects.equals(this.estimatedStart, generateWTCStatusResponse.estimatedStart) &&
        Objects.equals(this.estimatedEnd, generateWTCStatusResponse.estimatedEnd) &&
        Objects.equals(this.status, generateWTCStatusResponse.status) &&
        Objects.equals(this.id, generateWTCStatusResponse.id) &&
        Objects.equals(this.eMail, generateWTCStatusResponse.eMail) &&
        Objects.equals(this.generationId, generateWTCStatusResponse.generationId) &&
        Objects.equals(this.created, generateWTCStatusResponse.created) &&
        Objects.equals(this.sdkVersion, generateWTCStatusResponse.sdkVersion);
  }

  @Override
  public int hashCode() {
    return Objects.hash(payload, estimatedStart, estimatedEnd, status, id, eMail, generationId, created, sdkVersion);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GenerateWTCStatusResponse {\n");
    sb.append("    payload: ").append(toIndentedString(payload)).append("\n");
    sb.append("    estimatedStart: ").append(toIndentedString(estimatedStart)).append("\n");
    sb.append("    estimatedEnd: ").append(toIndentedString(estimatedEnd)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    eMail: ").append(toIndentedString(eMail)).append("\n");
    sb.append("    generationId: ").append(toIndentedString(generationId)).append("\n");
    sb.append("    created: ").append(toIndentedString(created)).append("\n");
    sb.append("    sdkVersion: ").append(toIndentedString(sdkVersion)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

