/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * GenerateWTOBody
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class GenerateWTOBody {
  public static final String SERIALIZED_NAME_SDK_VERSION = "sdkVersion";
  @SerializedName(SERIALIZED_NAME_SDK_VERSION)
  private String sdkVersion;

  public static final String SERIALIZED_NAME_E_MAIL = "eMail";
  @SerializedName(SERIALIZED_NAME_E_MAIL)
  private String eMail;


  public GenerateWTOBody sdkVersion(String sdkVersion) {
    
    this.sdkVersion = sdkVersion;
    return this;
  }

   /**
   * Optional - Version of the Wikitude SDK the WTO resource will be generated for. Must be set to \&quot;8.0\&quot; since versions \&quot;7.0\&quot;, \&quot;7.1\&quot;, \&quot;7.2\&quot; are not supported anymore. Default: 8.0 
   * @return sdkVersion
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "8.0", value = "Optional - Version of the Wikitude SDK the WTO resource will be generated for. Must be set to \"8.0\" since versions \"7.0\", \"7.1\", \"7.2\" are not supported anymore. Default: 8.0 ")

  public String getSdkVersion() {
    return sdkVersion;
  }


  public void setSdkVersion(String sdkVersion) {
    this.sdkVersion = sdkVersion;
  }


  public GenerateWTOBody eMail(String eMail) {
    
    this.eMail = eMail;
    return this;
  }

   /**
   * Optional - The e-mail address, the notification is sent after the generation of the resource is finished. If non is specified, retrieve the generated resource from the corresponding generation status endpoint. 
   * @return eMail
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "noreply@wikitude.com", value = "Optional - The e-mail address, the notification is sent after the generation of the resource is finished. If non is specified, retrieve the generated resource from the corresponding generation status endpoint. ")

  public String geteMail() {
    return eMail;
  }


  public void seteMail(String eMail) {
    this.eMail = eMail;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GenerateWTOBody generateWTOBody = (GenerateWTOBody) o;
    return Objects.equals(this.sdkVersion, generateWTOBody.sdkVersion) &&
        Objects.equals(this.eMail, generateWTOBody.eMail);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sdkVersion, eMail);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GenerateWTOBody {\n");
    sb.append("    sdkVersion: ").append(toIndentedString(sdkVersion)).append("\n");
    sb.append("    eMail: ").append(toIndentedString(eMail)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

