/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.openapitools.client.model.GetAccountInfoResponseStorage;

/**
 * User account information.
 */
@ApiModel(description = "User account information.")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class GetAccountInfoResponse {
  public static final String SERIALIZED_NAME_STORAGE = "storage";
  @SerializedName(SERIALIZED_NAME_STORAGE)
  private GetAccountInfoResponseStorage storage;

  public static final String SERIALIZED_NAME_USER_EMAIL = "userEmail";
  @SerializedName(SERIALIZED_NAME_USER_EMAIL)
  private String userEmail;

  public static final String SERIALIZED_NAME_PUBLIC_USER_ID = "publicUserId";
  @SerializedName(SERIALIZED_NAME_PUBLIC_USER_ID)
  private String publicUserId;


  public GetAccountInfoResponse storage(GetAccountInfoResponseStorage storage) {
    
    this.storage = storage;
    return this;
  }

   /**
   * Get storage
   * @return storage
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public GetAccountInfoResponseStorage getStorage() {
    return storage;
  }


  public void setStorage(GetAccountInfoResponseStorage storage) {
    this.storage = storage;
  }


  public GetAccountInfoResponse userEmail(String userEmail) {
    
    this.userEmail = userEmail;
    return this;
  }

   /**
   * The e-mail address of the user account.
   * @return userEmail
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "noreply@wikitude.com", value = "The e-mail address of the user account.")

  public String getUserEmail() {
    return userEmail;
  }


  public void setUserEmail(String userEmail) {
    this.userEmail = userEmail;
  }


  public GetAccountInfoResponse publicUserId(String publicUserId) {
    
    this.publicUserId = publicUserId;
    return this;
  }

   /**
   * This id, also communicated as groupId, is a unique identifier and used for cloud recognition.
   * @return publicUserId
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "abcdefgh", value = "This id, also communicated as groupId, is a unique identifier and used for cloud recognition.")

  public String getPublicUserId() {
    return publicUserId;
  }


  public void setPublicUserId(String publicUserId) {
    this.publicUserId = publicUserId;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GetAccountInfoResponse getAccountInfoResponse = (GetAccountInfoResponse) o;
    return Objects.equals(this.storage, getAccountInfoResponse.storage) &&
        Objects.equals(this.userEmail, getAccountInfoResponse.userEmail) &&
        Objects.equals(this.publicUserId, getAccountInfoResponse.publicUserId);
  }

  @Override
  public int hashCode() {
    return Objects.hash(storage, userEmail, publicUserId);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GetAccountInfoResponse {\n");
    sb.append("    storage: ").append(toIndentedString(storage)).append("\n");
    sb.append("    userEmail: ").append(toIndentedString(userEmail)).append("\n");
    sb.append("    publicUserId: ").append(toIndentedString(publicUserId)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

