/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import org.openapitools.client.model.ImageTargetCollectionResponseCloudArchive;
import org.openapitools.client.model.ImageTargetCollectionResponseWtc;

/**
 * ImageTargetCollectionResponse
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class ImageTargetCollectionResponse {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private String type;

  public static final String SERIALIZED_NAME_WTC = "wtc";
  @SerializedName(SERIALIZED_NAME_WTC)
  private List<ImageTargetCollectionResponseWtc> wtc = null;

  public static final String SERIALIZED_NAME_MOD_DAT = "modDat";
  @SerializedName(SERIALIZED_NAME_MOD_DAT)
  private BigDecimal modDat;

  public static final String SERIALIZED_NAME_CRE_DAT = "creDat";
  @SerializedName(SERIALIZED_NAME_CRE_DAT)
  private BigDecimal creDat;

  public static final String SERIALIZED_NAME_METADATA = "metadata";
  @SerializedName(SERIALIZED_NAME_METADATA)
  private Object metadata;

  public static final String SERIALIZED_NAME_CLOUD_ARCHIVE = "cloudArchive";
  @SerializedName(SERIALIZED_NAME_CLOUD_ARCHIVE)
  private ImageTargetCollectionResponseCloudArchive cloudArchive;


  public ImageTargetCollectionResponse id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Unique identifier of the Target Collection.
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "tcId00000000000000000001", value = "Unique identifier of the Target Collection.")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public ImageTargetCollectionResponse name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Name of the Target Collection.
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Some Target Collection", value = "Name of the Target Collection.")

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public ImageTargetCollectionResponse type(String type) {
    
    this.type = type;
    return this;
  }

   /**
   * Type of the Target Collection (\&quot;ImageTargetCollection\&quot; or \&quot;ObjectTargetCollection\&quot;).
   * @return type
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "ImageTargetCollection", value = "Type of the Target Collection (\"ImageTargetCollection\" or \"ObjectTargetCollection\").")

  public String getType() {
    return type;
  }


  public void setType(String type) {
    this.type = type;
  }


  public ImageTargetCollectionResponse wtc(List<ImageTargetCollectionResponseWtc> wtc) {
    
    this.wtc = wtc;
    return this;
  }

  public ImageTargetCollectionResponse addWtcItem(ImageTargetCollectionResponseWtc wtcItem) {
    if (this.wtc == null) {
      this.wtc = new ArrayList<ImageTargetCollectionResponseWtc>();
    }
    this.wtc.add(wtcItem);
    return this;
  }

   /**
   * A list of generated WTC files.
   * @return wtc
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "A list of generated WTC files.")

  public List<ImageTargetCollectionResponseWtc> getWtc() {
    return wtc;
  }


  public void setWtc(List<ImageTargetCollectionResponseWtc> wtc) {
    this.wtc = wtc;
  }


  public ImageTargetCollectionResponse modDat(BigDecimal modDat) {
    
    this.modDat = modDat;
    return this;
  }

   /**
   * Modification timestamp.
   * @return modDat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069533660", value = "Modification timestamp.")

  public BigDecimal getModDat() {
    return modDat;
  }


  public void setModDat(BigDecimal modDat) {
    this.modDat = modDat;
  }


  public ImageTargetCollectionResponse creDat(BigDecimal creDat) {
    
    this.creDat = creDat;
    return this;
  }

   /**
   * Creation timestamp.
   * @return creDat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069526660", value = "Creation timestamp.")

  public BigDecimal getCreDat() {
    return creDat;
  }


  public void setCreDat(BigDecimal creDat) {
    this.creDat = creDat;
  }


  public ImageTargetCollectionResponse metadata(Object metadata) {
    
    this.metadata = metadata;
    return this;
  }

   /**
   * Arbitrary JSON data that should be stored together with the Target Collection.
   * @return metadata
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "{\"key\":\"value\"}", value = "Arbitrary JSON data that should be stored together with the Target Collection.")

  public Object getMetadata() {
    return metadata;
  }


  public void setMetadata(Object metadata) {
    this.metadata = metadata;
  }


  public ImageTargetCollectionResponse cloudArchive(ImageTargetCollectionResponseCloudArchive cloudArchive) {
    
    this.cloudArchive = cloudArchive;
    return this;
  }

   /**
   * Get cloudArchive
   * @return cloudArchive
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ImageTargetCollectionResponseCloudArchive getCloudArchive() {
    return cloudArchive;
  }


  public void setCloudArchive(ImageTargetCollectionResponseCloudArchive cloudArchive) {
    this.cloudArchive = cloudArchive;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImageTargetCollectionResponse imageTargetCollectionResponse = (ImageTargetCollectionResponse) o;
    return Objects.equals(this.id, imageTargetCollectionResponse.id) &&
        Objects.equals(this.name, imageTargetCollectionResponse.name) &&
        Objects.equals(this.type, imageTargetCollectionResponse.type) &&
        Objects.equals(this.wtc, imageTargetCollectionResponse.wtc) &&
        Objects.equals(this.modDat, imageTargetCollectionResponse.modDat) &&
        Objects.equals(this.creDat, imageTargetCollectionResponse.creDat) &&
        Objects.equals(this.metadata, imageTargetCollectionResponse.metadata) &&
        Objects.equals(this.cloudArchive, imageTargetCollectionResponse.cloudArchive);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, type, wtc, modDat, creDat, metadata, cloudArchive);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImageTargetCollectionResponse {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    wtc: ").append(toIndentedString(wtc)).append("\n");
    sb.append("    modDat: ").append(toIndentedString(modDat)).append("\n");
    sb.append("    creDat: ").append(toIndentedString(creDat)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    cloudArchive: ").append(toIndentedString(cloudArchive)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

