/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * ImageTargetCollectionResponseCloudArchive
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class ImageTargetCollectionResponseCloudArchive {
  public static final String SERIALIZED_NAME_ENABLED = "enabled";
  @SerializedName(SERIALIZED_NAME_ENABLED)
  private Boolean enabled;

  public static final String SERIALIZED_NAME_VERSION = "version";
  @SerializedName(SERIALIZED_NAME_VERSION)
  private String version;

  public static final String SERIALIZED_NAME_VALIDITY_KEY_DATE = "validityKeyDate";
  @SerializedName(SERIALIZED_NAME_VALIDITY_KEY_DATE)
  private String validityKeyDate;


  public ImageTargetCollectionResponseCloudArchive enabled(Boolean enabled) {
    
    this.enabled = enabled;
    return this;
  }

   /**
   * Activates an Image Target Collection for cloud recognition. All containing Image Targets are added to the quota. If the value is \&quot;false\&quot;, the cloud archive can not be generated and an error is returned by the cloud archive generation endpoint. Default: true 
   * @return enabled
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "Activates an Image Target Collection for cloud recognition. All containing Image Targets are added to the quota. If the value is \"false\", the cloud archive can not be generated and an error is returned by the cloud archive generation endpoint. Default: true ")

  public Boolean getEnabled() {
    return enabled;
  }


  public void setEnabled(Boolean enabled) {
    this.enabled = enabled;
  }


  public ImageTargetCollectionResponseCloudArchive version(String version) {
    
    this.version = version;
    return this;
  }

   /**
   * Version of the latest cloud archive.
   * @return version
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2.0", value = "Version of the latest cloud archive.")

  public String getVersion() {
    return version;
  }


  public void setVersion(String version) {
    this.version = version;
  }


  public ImageTargetCollectionResponseCloudArchive validityKeyDate(String validityKeyDate) {
    
    this.validityKeyDate = validityKeyDate;
    return this;
  }

   /**
   * Timestamp of the latest cloud archive generation.
   * @return validityKeyDate
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "2020-08-10T09:28:10.631Z", value = "Timestamp of the latest cloud archive generation.")

  public String getValidityKeyDate() {
    return validityKeyDate;
  }


  public void setValidityKeyDate(String validityKeyDate) {
    this.validityKeyDate = validityKeyDate;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImageTargetCollectionResponseCloudArchive imageTargetCollectionResponseCloudArchive = (ImageTargetCollectionResponseCloudArchive) o;
    return Objects.equals(this.enabled, imageTargetCollectionResponseCloudArchive.enabled) &&
        Objects.equals(this.version, imageTargetCollectionResponseCloudArchive.version) &&
        Objects.equals(this.validityKeyDate, imageTargetCollectionResponseCloudArchive.validityKeyDate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(enabled, version, validityKeyDate);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImageTargetCollectionResponseCloudArchive {\n");
    sb.append("    enabled: ").append(toIndentedString(enabled)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    validityKeyDate: ").append(toIndentedString(validityKeyDate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

