/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * ImageTargetResponse
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class ImageTargetResponse {
  public static final String SERIALIZED_NAME_THUMBNAIL_URL = "thumbnailUrl";
  @SerializedName(SERIALIZED_NAME_THUMBNAIL_URL)
  private String thumbnailUrl;

  public static final String SERIALIZED_NAME_RATING = "rating";
  @SerializedName(SERIALIZED_NAME_RATING)
  private BigDecimal rating;

  public static final String SERIALIZED_NAME_DISTRIBUTION = "distribution";
  @SerializedName(SERIALIZED_NAME_DISTRIBUTION)
  private BigDecimal distribution;

  public static final String SERIALIZED_NAME_FILE_SIZE = "fileSize";
  @SerializedName(SERIALIZED_NAME_FILE_SIZE)
  private BigDecimal fileSize;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_IMAGE_URL = "imageUrl";
  @SerializedName(SERIALIZED_NAME_IMAGE_URL)
  private String imageUrl;

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private String type;

  public static final String SERIALIZED_NAME_MOD_DAT = "modDat";
  @SerializedName(SERIALIZED_NAME_MOD_DAT)
  private BigDecimal modDat;

  public static final String SERIALIZED_NAME_CRE_DAT = "creDat";
  @SerializedName(SERIALIZED_NAME_CRE_DAT)
  private BigDecimal creDat;

  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_METADATA = "metadata";
  @SerializedName(SERIALIZED_NAME_METADATA)
  private String metadata;

  public static final String SERIALIZED_NAME_PHYSICAL_HEIGHT = "physicalHeight";
  @SerializedName(SERIALIZED_NAME_PHYSICAL_HEIGHT)
  private BigDecimal physicalHeight;


  public ImageTargetResponse thumbnailUrl(String thumbnailUrl) {
    
    this.thumbnailUrl = thumbnailUrl;
    return this;
  }

   /**
   * URL to the Target resource thumbnail.
   * @return thumbnailUrl
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://wikitudeUrl.com/img_thumb.jpg", value = "URL to the Target resource thumbnail.")

  public String getThumbnailUrl() {
    return thumbnailUrl;
  }


  public void setThumbnailUrl(String thumbnailUrl) {
    this.thumbnailUrl = thumbnailUrl;
  }


  public ImageTargetResponse rating(BigDecimal rating) {
    
    this.rating = rating;
    return this;
  }

   /**
   * The star rating indicates the quality of the target, i.e. how well the target is recognized on the device. The more stars a target has, the better it can be recognized and tracked. 
   * @return rating
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3", value = "The star rating indicates the quality of the target, i.e. how well the target is recognized on the device. The more stars a target has, the better it can be recognized and tracked. ")

  public BigDecimal getRating() {
    return rating;
  }


  public void setRating(BigDecimal rating) {
    this.rating = rating;
  }


  public ImageTargetResponse distribution(BigDecimal distribution) {
    
    this.distribution = distribution;
    return this;
  }

   /**
   * The distribution rating indicates how well feature-points scatter over the target image. The higher the rating, the more reliable it can be recognized and tracked, even if partly covered. 
   * @return distribution
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3", value = "The distribution rating indicates how well feature-points scatter over the target image. The higher the rating, the more reliable it can be recognized and tracked, even if partly covered. ")

  public BigDecimal getDistribution() {
    return distribution;
  }


  public void setDistribution(BigDecimal distribution) {
    this.distribution = distribution;
  }


  public ImageTargetResponse fileSize(BigDecimal fileSize) {
    
    this.fileSize = fileSize;
    return this;
  }

   /**
   * File size of the stored resource.
   * @return fileSize
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1038481", value = "File size of the stored resource.")

  public BigDecimal getFileSize() {
    return fileSize;
  }


  public void setFileSize(BigDecimal fileSize) {
    this.fileSize = fileSize;
  }


  public ImageTargetResponse name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Name of the Target.
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Some Target", value = "Name of the Target.")

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public ImageTargetResponse imageUrl(String imageUrl) {
    
    this.imageUrl = imageUrl;
    return this;
  }

   /**
   * URL to the Target Image resource.
   * @return imageUrl
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://wikitudeUrl.com/img.jpg", value = "URL to the Target Image resource.")

  public String getImageUrl() {
    return imageUrl;
  }


  public void setImageUrl(String imageUrl) {
    this.imageUrl = imageUrl;
  }


  public ImageTargetResponse type(String type) {
    
    this.type = type;
    return this;
  }

   /**
   * Type of the Target (\&quot;Image\&quot; for Image Targets or \&quot;Object\&quot; for Object Targets).
   * @return type
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Image", value = "Type of the Target (\"Image\" for Image Targets or \"Object\" for Object Targets).")

  public String getType() {
    return type;
  }


  public void setType(String type) {
    this.type = type;
  }


  public ImageTargetResponse modDat(BigDecimal modDat) {
    
    this.modDat = modDat;
    return this;
  }

   /**
   * Modification timestamp.
   * @return modDat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069533660", value = "Modification timestamp.")

  public BigDecimal getModDat() {
    return modDat;
  }


  public void setModDat(BigDecimal modDat) {
    this.modDat = modDat;
  }


  public ImageTargetResponse creDat(BigDecimal creDat) {
    
    this.creDat = creDat;
    return this;
  }

   /**
   * Creation timestamp.
   * @return creDat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069526660", value = "Creation timestamp.")

  public BigDecimal getCreDat() {
    return creDat;
  }


  public void setCreDat(BigDecimal creDat) {
    this.creDat = creDat;
  }


  public ImageTargetResponse id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Unique identifier of the Target.
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "target000000000000000001", value = "Unique identifier of the Target.")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public ImageTargetResponse metadata(String metadata) {
    
    this.metadata = metadata;
    return this;
  }

   /**
   * Arbitrary JSON data that should be stored together with the Target.
   * @return metadata
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "{\"key\":\"value\"}", value = "Arbitrary JSON data that should be stored together with the Target.")

  public String getMetadata() {
    return metadata;
  }


  public void setMetadata(String metadata) {
    this.metadata = metadata;
  }


  public ImageTargetResponse physicalHeight(BigDecimal physicalHeight) {
    
    this.physicalHeight = physicalHeight;
    return this;
  }

   /**
   * The physical (real world) height of the target, in millimeters.
   * @return physicalHeight
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "42", value = "The physical (real world) height of the target, in millimeters.")

  public BigDecimal getPhysicalHeight() {
    return physicalHeight;
  }


  public void setPhysicalHeight(BigDecimal physicalHeight) {
    this.physicalHeight = physicalHeight;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ImageTargetResponse imageTargetResponse = (ImageTargetResponse) o;
    return Objects.equals(this.thumbnailUrl, imageTargetResponse.thumbnailUrl) &&
        Objects.equals(this.rating, imageTargetResponse.rating) &&
        Objects.equals(this.distribution, imageTargetResponse.distribution) &&
        Objects.equals(this.fileSize, imageTargetResponse.fileSize) &&
        Objects.equals(this.name, imageTargetResponse.name) &&
        Objects.equals(this.imageUrl, imageTargetResponse.imageUrl) &&
        Objects.equals(this.type, imageTargetResponse.type) &&
        Objects.equals(this.modDat, imageTargetResponse.modDat) &&
        Objects.equals(this.creDat, imageTargetResponse.creDat) &&
        Objects.equals(this.id, imageTargetResponse.id) &&
        Objects.equals(this.metadata, imageTargetResponse.metadata) &&
        Objects.equals(this.physicalHeight, imageTargetResponse.physicalHeight);
  }

  @Override
  public int hashCode() {
    return Objects.hash(thumbnailUrl, rating, distribution, fileSize, name, imageUrl, type, modDat, creDat, id, metadata, physicalHeight);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ImageTargetResponse {\n");
    sb.append("    thumbnailUrl: ").append(toIndentedString(thumbnailUrl)).append("\n");
    sb.append("    rating: ").append(toIndentedString(rating)).append("\n");
    sb.append("    distribution: ").append(toIndentedString(distribution)).append("\n");
    sb.append("    fileSize: ").append(toIndentedString(fileSize)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    imageUrl: ").append(toIndentedString(imageUrl)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    modDat: ").append(toIndentedString(modDat)).append("\n");
    sb.append("    creDat: ").append(toIndentedString(creDat)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    metadata: ").append(toIndentedString(metadata)).append("\n");
    sb.append("    physicalHeight: ").append(toIndentedString(physicalHeight)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

