/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * ObjectTargetCollectionResponseWto
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class ObjectTargetCollectionResponseWto {
  public static final String SERIALIZED_NAME_NR_OF_TARGETS = "nrOfTargets";
  @SerializedName(SERIALIZED_NAME_NR_OF_TARGETS)
  private BigDecimal nrOfTargets;

  public static final String SERIALIZED_NAME_VERSION = "version";
  @SerializedName(SERIALIZED_NAME_VERSION)
  private String version;

  public static final String SERIALIZED_NAME_URL = "url";
  @SerializedName(SERIALIZED_NAME_URL)
  private String url;

  public static final String SERIALIZED_NAME_CRE_DAT = "creDat";
  @SerializedName(SERIALIZED_NAME_CRE_DAT)
  private BigDecimal creDat;


  public ObjectTargetCollectionResponseWto nrOfTargets(BigDecimal nrOfTargets) {
    
    this.nrOfTargets = nrOfTargets;
    return this;
  }

   /**
   * Number of Targets bundled in the WTO resource.
   * @return nrOfTargets
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3", value = "Number of Targets bundled in the WTO resource.")

  public BigDecimal getNrOfTargets() {
    return nrOfTargets;
  }


  public void setNrOfTargets(BigDecimal nrOfTargets) {
    this.nrOfTargets = nrOfTargets;
  }


  public ObjectTargetCollectionResponseWto version(String version) {
    
    this.version = version;
    return this;
  }

   /**
   * Version of the Wikitude SDK the WTO resource was generated for.
   * @return version
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "8.0", value = "Version of the Wikitude SDK the WTO resource was generated for.")

  public String getVersion() {
    return version;
  }


  public void setVersion(String version) {
    this.version = version;
  }


  public ObjectTargetCollectionResponseWto url(String url) {
    
    this.url = url;
    return this;
  }

   /**
   * URL to the WTO resource.
   * @return url
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://wikitudeUrl.com/tracker.wto", value = "URL to the WTO resource.")

  public String getUrl() {
    return url;
  }


  public void setUrl(String url) {
    this.url = url;
  }


  public ObjectTargetCollectionResponseWto creDat(BigDecimal creDat) {
    
    this.creDat = creDat;
    return this;
  }

   /**
   * Creation timestamp.
   * @return creDat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069526660", value = "Creation timestamp.")

  public BigDecimal getCreDat() {
    return creDat;
  }


  public void setCreDat(BigDecimal creDat) {
    this.creDat = creDat;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ObjectTargetCollectionResponseWto objectTargetCollectionResponseWto = (ObjectTargetCollectionResponseWto) o;
    return Objects.equals(this.nrOfTargets, objectTargetCollectionResponseWto.nrOfTargets) &&
        Objects.equals(this.version, objectTargetCollectionResponseWto.version) &&
        Objects.equals(this.url, objectTargetCollectionResponseWto.url) &&
        Objects.equals(this.creDat, objectTargetCollectionResponseWto.creDat);
  }

  @Override
  public int hashCode() {
    return Objects.hash(nrOfTargets, version, url, creDat);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ObjectTargetCollectionResponseWto {\n");
    sb.append("    nrOfTargets: ").append(toIndentedString(nrOfTargets)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    creDat: ").append(toIndentedString(creDat)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

