/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import org.openapitools.client.model.ObjectTargetResponseResource;
import org.openapitools.client.model.ObjectTargetResponseWtoFile;

/**
 * ObjectTargetResponse
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class ObjectTargetResponse {
  public static final String SERIALIZED_NAME_ID = "id";
  @SerializedName(SERIALIZED_NAME_ID)
  private String id;

  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_TYPE = "type";
  @SerializedName(SERIALIZED_NAME_TYPE)
  private String type;

  public static final String SERIALIZED_NAME_FILE_SIZE = "fileSize";
  @SerializedName(SERIALIZED_NAME_FILE_SIZE)
  private BigDecimal fileSize;

  public static final String SERIALIZED_NAME_MOD_DAT = "modDat";
  @SerializedName(SERIALIZED_NAME_MOD_DAT)
  private BigDecimal modDat;

  public static final String SERIALIZED_NAME_CRE_DAT = "creDat";
  @SerializedName(SERIALIZED_NAME_CRE_DAT)
  private BigDecimal creDat;

  public static final String SERIALIZED_NAME_IS_EXPANDABLE = "isExpandable";
  @SerializedName(SERIALIZED_NAME_IS_EXPANDABLE)
  private Boolean isExpandable;

  public static final String SERIALIZED_NAME_REAL_WORLD_SCALE = "realWorldScale";
  @SerializedName(SERIALIZED_NAME_REAL_WORLD_SCALE)
  private BigDecimal realWorldScale;

  public static final String SERIALIZED_NAME_RESOURCE = "resource";
  @SerializedName(SERIALIZED_NAME_RESOURCE)
  private ObjectTargetResponseResource resource;

  public static final String SERIALIZED_NAME_THUMBNAIL_URL = "thumbnailUrl";
  @SerializedName(SERIALIZED_NAME_THUMBNAIL_URL)
  private String thumbnailUrl;

  public static final String SERIALIZED_NAME_WTO_FILE = "wtoFile";
  @SerializedName(SERIALIZED_NAME_WTO_FILE)
  private ObjectTargetResponseWtoFile wtoFile;


  public ObjectTargetResponse id(String id) {
    
    this.id = id;
    return this;
  }

   /**
   * Unique identifier of the Target.
   * @return id
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "target000000000000000001", value = "Unique identifier of the Target.")

  public String getId() {
    return id;
  }


  public void setId(String id) {
    this.id = id;
  }


  public ObjectTargetResponse name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Name of the Target.
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Some Target", value = "Name of the Target.")

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public ObjectTargetResponse type(String type) {
    
    this.type = type;
    return this;
  }

   /**
   * Type of the Target (\&quot;Image\&quot; for Image Targets or \&quot;Object\&quot; for Object Targets).
   * @return type
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Object", value = "Type of the Target (\"Image\" for Image Targets or \"Object\" for Object Targets).")

  public String getType() {
    return type;
  }


  public void setType(String type) {
    this.type = type;
  }


  public ObjectTargetResponse fileSize(BigDecimal fileSize) {
    
    this.fileSize = fileSize;
    return this;
  }

   /**
   * File size of the stored resource.
   * @return fileSize
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1038481", value = "File size of the stored resource.")

  public BigDecimal getFileSize() {
    return fileSize;
  }


  public void setFileSize(BigDecimal fileSize) {
    this.fileSize = fileSize;
  }


  public ObjectTargetResponse modDat(BigDecimal modDat) {
    
    this.modDat = modDat;
    return this;
  }

   /**
   * Modification timestamp.
   * @return modDat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069533660", value = "Modification timestamp.")

  public BigDecimal getModDat() {
    return modDat;
  }


  public void setModDat(BigDecimal modDat) {
    this.modDat = modDat;
  }


  public ObjectTargetResponse creDat(BigDecimal creDat) {
    
    this.creDat = creDat;
    return this;
  }

   /**
   * Creation timestamp.
   * @return creDat
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "1597069526660", value = "Creation timestamp.")

  public BigDecimal getCreDat() {
    return creDat;
  }


  public void setCreDat(BigDecimal creDat) {
    this.creDat = creDat;
  }


  public ObjectTargetResponse isExpandable(Boolean isExpandable) {
    
    this.isExpandable = isExpandable;
    return this;
  }

   /**
   * Indicates if an Object Target is extendable to improve tracking and recognition quality. Only Image-based Object Targets are extendable. 
   * @return isExpandable
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "true", value = "Indicates if an Object Target is extendable to improve tracking and recognition quality. Only Image-based Object Targets are extendable. ")

  public Boolean getIsExpandable() {
    return isExpandable;
  }


  public void setIsExpandable(Boolean isExpandable) {
    this.isExpandable = isExpandable;
  }


  public ObjectTargetResponse realWorldScale(BigDecimal realWorldScale) {
    
    this.realWorldScale = realWorldScale;
    return this;
  }

   /**
   * The physical (real world) size of the Target, in millimeters. Set to null to reset.
   * @return realWorldScale
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "42", value = "The physical (real world) size of the Target, in millimeters. Set to null to reset.")

  public BigDecimal getRealWorldScale() {
    return realWorldScale;
  }


  public void setRealWorldScale(BigDecimal realWorldScale) {
    this.realWorldScale = realWorldScale;
  }


  public ObjectTargetResponse resource(ObjectTargetResponseResource resource) {
    
    this.resource = resource;
    return this;
  }

   /**
   * Get resource
   * @return resource
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ObjectTargetResponseResource getResource() {
    return resource;
  }


  public void setResource(ObjectTargetResponseResource resource) {
    this.resource = resource;
  }


  public ObjectTargetResponse thumbnailUrl(String thumbnailUrl) {
    
    this.thumbnailUrl = thumbnailUrl;
    return this;
  }

   /**
   * URL to the Target resource thumbnail.
   * @return thumbnailUrl
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://wikitudeUrl.com/img_thumb.jpg", value = "URL to the Target resource thumbnail.")

  public String getThumbnailUrl() {
    return thumbnailUrl;
  }


  public void setThumbnailUrl(String thumbnailUrl) {
    this.thumbnailUrl = thumbnailUrl;
  }


  public ObjectTargetResponse wtoFile(ObjectTargetResponseWtoFile wtoFile) {
    
    this.wtoFile = wtoFile;
    return this;
  }

   /**
   * Get wtoFile
   * @return wtoFile
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public ObjectTargetResponseWtoFile getWtoFile() {
    return wtoFile;
  }


  public void setWtoFile(ObjectTargetResponseWtoFile wtoFile) {
    this.wtoFile = wtoFile;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ObjectTargetResponse objectTargetResponse = (ObjectTargetResponse) o;
    return Objects.equals(this.id, objectTargetResponse.id) &&
        Objects.equals(this.name, objectTargetResponse.name) &&
        Objects.equals(this.type, objectTargetResponse.type) &&
        Objects.equals(this.fileSize, objectTargetResponse.fileSize) &&
        Objects.equals(this.modDat, objectTargetResponse.modDat) &&
        Objects.equals(this.creDat, objectTargetResponse.creDat) &&
        Objects.equals(this.isExpandable, objectTargetResponse.isExpandable) &&
        Objects.equals(this.realWorldScale, objectTargetResponse.realWorldScale) &&
        Objects.equals(this.resource, objectTargetResponse.resource) &&
        Objects.equals(this.thumbnailUrl, objectTargetResponse.thumbnailUrl) &&
        Objects.equals(this.wtoFile, objectTargetResponse.wtoFile);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, type, fileSize, modDat, creDat, isExpandable, realWorldScale, resource, thumbnailUrl, wtoFile);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ObjectTargetResponse {\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    fileSize: ").append(toIndentedString(fileSize)).append("\n");
    sb.append("    modDat: ").append(toIndentedString(modDat)).append("\n");
    sb.append("    creDat: ").append(toIndentedString(creDat)).append("\n");
    sb.append("    isExpandable: ").append(toIndentedString(isExpandable)).append("\n");
    sb.append("    realWorldScale: ").append(toIndentedString(realWorldScale)).append("\n");
    sb.append("    resource: ").append(toIndentedString(resource)).append("\n");
    sb.append("    thumbnailUrl: ").append(toIndentedString(thumbnailUrl)).append("\n");
    sb.append("    wtoFile: ").append(toIndentedString(wtoFile)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

