/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * ObjectTargetResponseResource
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class ObjectTargetResponseResource {
  public static final String SERIALIZED_NAME_FOV = "fov";
  @SerializedName(SERIALIZED_NAME_FOV)
  private BigDecimal fov;

  public static final String SERIALIZED_NAME_URI = "uri";
  @SerializedName(SERIALIZED_NAME_URI)
  private List<String> uri = null;


  public ObjectTargetResponseResource fov(BigDecimal fov) {
    
    this.fov = fov;
    return this;
  }

   /**
   * Field of view.
   * @return fov
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "60", value = "Field of view.")

  public BigDecimal getFov() {
    return fov;
  }


  public void setFov(BigDecimal fov) {
    this.fov = fov;
  }


  public ObjectTargetResponseResource uri(List<String> uri) {
    
    this.uri = uri;
    return this;
  }

  public ObjectTargetResponseResource addUriItem(String uriItem) {
    if (this.uri == null) {
      this.uri = new ArrayList<String>();
    }
    this.uri.add(uriItem);
    return this;
  }

   /**
   * List of image resource URLs the Object Target was generated with.
   * @return uri
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "List of image resource URLs the Object Target was generated with.")

  public List<String> getUri() {
    return uri;
  }


  public void setUri(List<String> uri) {
    this.uri = uri;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ObjectTargetResponseResource objectTargetResponseResource = (ObjectTargetResponseResource) o;
    return Objects.equals(this.fov, objectTargetResponseResource.fov) &&
        Objects.equals(this.uri, objectTargetResponseResource.uri);
  }

  @Override
  public int hashCode() {
    return Objects.hash(fov, uri);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ObjectTargetResponseResource {\n");
    sb.append("    fov: ").append(toIndentedString(fov)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

