/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * ObjectTargetResponseWtoFile
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class ObjectTargetResponseWtoFile {
  public static final String SERIALIZED_NAME_TRANSFORMED_J_S_O_N_URI = "transformedJSONUri";
  @SerializedName(SERIALIZED_NAME_TRANSFORMED_J_S_O_N_URI)
  private String transformedJSONUri;

  public static final String SERIALIZED_NAME_URI = "uri";
  @SerializedName(SERIALIZED_NAME_URI)
  private String uri;

  public static final String SERIALIZED_NAME_POINT_COUNT = "pointCount";
  @SerializedName(SERIALIZED_NAME_POINT_COUNT)
  private BigDecimal pointCount;


  public ObjectTargetResponseWtoFile transformedJSONUri(String transformedJSONUri) {
    
    this.transformedJSONUri = transformedJSONUri;
    return this;
  }

   /**
   * URL to the transformation json resource.
   * @return transformedJSONUri
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://wikitudeUrl.com/transformed.json", value = "URL to the transformation json resource.")

  public String getTransformedJSONUri() {
    return transformedJSONUri;
  }


  public void setTransformedJSONUri(String transformedJSONUri) {
    this.transformedJSONUri = transformedJSONUri;
  }


  public ObjectTargetResponseWtoFile uri(String uri) {
    
    this.uri = uri;
    return this;
  }

   /**
   * URL to the WTO resource.
   * @return uri
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "https://wikitudeUrl.com/target.wto", value = "URL to the WTO resource.")

  public String getUri() {
    return uri;
  }


  public void setUri(String uri) {
    this.uri = uri;
  }


  public ObjectTargetResponseWtoFile pointCount(BigDecimal pointCount) {
    
    this.pointCount = pointCount;
    return this;
  }

   /**
   * Number of distinct points in the point cloud.
   * @return pointCount
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "3000", value = "Number of distinct points in the point cloud.")

  public BigDecimal getPointCount() {
    return pointCount;
  }


  public void setPointCount(BigDecimal pointCount) {
    this.pointCount = pointCount;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ObjectTargetResponseWtoFile objectTargetResponseWtoFile = (ObjectTargetResponseWtoFile) o;
    return Objects.equals(this.transformedJSONUri, objectTargetResponseWtoFile.transformedJSONUri) &&
        Objects.equals(this.uri, objectTargetResponseWtoFile.uri) &&
        Objects.equals(this.pointCount, objectTargetResponseWtoFile.pointCount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(transformedJSONUri, uri, pointCount);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ObjectTargetResponseWtoFile {\n");
    sb.append("    transformedJSONUri: ").append(toIndentedString(transformedJSONUri)).append("\n");
    sb.append("    uri: ").append(toIndentedString(uri)).append("\n");
    sb.append("    pointCount: ").append(toIndentedString(pointCount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

