/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.math.BigDecimal;

/**
 * RenameObjectTargetBody
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2021-09-01T07:29:43.930Z[GMT]")
public class RenameObjectTargetBody {
  public static final String SERIALIZED_NAME_NAME = "name";
  @SerializedName(SERIALIZED_NAME_NAME)
  private String name;

  public static final String SERIALIZED_NAME_REAL_WORLD_SCALE = "realWorldScale";
  @SerializedName(SERIALIZED_NAME_REAL_WORLD_SCALE)
  private BigDecimal realWorldScale;


  public RenameObjectTargetBody name(String name) {
    
    this.name = name;
    return this;
  }

   /**
   * Required - Name of the Target.
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Some Target", value = "Required - Name of the Target.")

  public String getName() {
    return name;
  }


  public void setName(String name) {
    this.name = name;
  }


  public RenameObjectTargetBody realWorldScale(BigDecimal realWorldScale) {
    
    this.realWorldScale = realWorldScale;
    return this;
  }

   /**
   * Optional - The physical (real world) size of the Target, in millimeters. Set to null to reset.
   * minimum: 0
   * @return realWorldScale
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "42", value = "Optional - The physical (real world) size of the Target, in millimeters. Set to null to reset.")

  public BigDecimal getRealWorldScale() {
    return realWorldScale;
  }


  public void setRealWorldScale(BigDecimal realWorldScale) {
    this.realWorldScale = realWorldScale;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    RenameObjectTargetBody renameObjectTargetBody = (RenameObjectTargetBody) o;
    return Objects.equals(this.name, renameObjectTargetBody.name) &&
        Objects.equals(this.realWorldScale, renameObjectTargetBody.realWorldScale);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, realWorldScale);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class RenameObjectTargetBody {\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    realWorldScale: ").append(toIndentedString(realWorldScale)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

