/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.GenerateHeatmapBody;
import org.openapitools.client.model.GenerateHeatmapResponse;
import org.openapitools.client.model.GenerateHeatmapStatusResponse;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for HeatmapApi
 */
@Ignore
public class HeatmapApiTest {

    private final HeatmapApi api = new HeatmapApi();

    
    /**
     * Generate Heatmap
     *
     * Generates a greyscale image out of the input image, where areas with recognition and tracking relevance are highlighted in color. This way one can better understand the rating of an image and see which areas have the highest importance for 2D recognition and tracking. Note that only JPG and non-transparent PNG files are accepted and the generated heatmap image is stored on a temporary folder which is deleted after 24 hours. Store the image on your own server in case you plan to use it in your user interface. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void generateHeatmapTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        GenerateHeatmapBody generateHeatmapBody = null;
        GenerateHeatmapResponse response = api.generateHeatmap(xVersion, xToken, contentType, generateHeatmapBody);

        // TODO: test validations
    }
    
    /**
     * Status - Generate Heatmap
     *
     * Retrieves information status about a particular scheduled heatmap creation.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getHeatmapStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String generationId = null;
        GenerateHeatmapStatusResponse response = api.getHeatmapStatus(xVersion, xToken, generationId);

        // TODO: test validations
    }
    
}
