/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import java.math.BigDecimal;
import org.openapitools.client.model.CreateImageTargetsBody;
import org.openapitools.client.model.CreateImageTargetsResponse;
import org.openapitools.client.model.ImageTargetResponse;
import org.openapitools.client.model.UpdateImageTargetBody;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ImageTargetApi
 */
@Ignore
public class ImageTargetApiTest {

    private final ImageTargetApi api = new ImageTargetApi();

    
    /**
     * Create Image Targets
     *
     * Create a set of up to 10 new Targets in a Target Collection in your account. The task to create the listed Targets is scheduled. The response body contains the initial job status. \&quot;Location\&quot;-header is the url to the GET endpoint that returns current job status information. It is recommended to query this endpoint after \&quot;estimatedLatency\&quot; milliseconds, and poll it afterwards every 10 seconds in case job status is still not \&quot;COMPLETED\&quot;. Once job status is \&quot;COMPLETED\&quot; each item holds a \&quot;target\&quot; attribute of the created target or an \&quot;error\&quot; attribute. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createImageTargetsTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        List<CreateImageTargetsBody> createImageTargetsBody = null;
        CreateImageTargetsResponse response = api.createImageTargets(xVersion, xToken, contentType, tcId, createImageTargetsBody);

        // TODO: test validations
    }
    
    /**
     * Delete Image Target
     *
     * Delete a particular Target from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteImageTargetTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String targetId = null;
        api.deleteImageTarget(xVersion, xToken, tcId, targetId);

        // TODO: test validations
    }
    
    /**
     * Get Image Target
     *
     * Request a particular Image Target in a particular Target Collection.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImageTargetTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String targetId = null;
        ImageTargetResponse response = api.getImageTarget(xVersion, xToken, tcId, targetId);

        // TODO: test validations
    }
    
    /**
     * Status - Image Targets Creation
     *
     * Retrieves information status about a particular scheduled targets creation.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImageTargetStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String generationId = null;
        CreateImageTargetsResponse response = api.getImageTargetStatus(xVersion, xToken, tcId, generationId);

        // TODO: test validations
    }
    
    /**
     * Get Image Targets
     *
     * Request all Image Targets in a Target Collection.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImageTargetsTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String sortby = null;
        String sortorder = null;
        BigDecimal skip = null;
        BigDecimal limit = null;
        String s = null;
        Boolean addHasAugmentations = null;
        List<ImageTargetResponse> response = api.getImageTargets(xVersion, xToken, tcId, sortby, sortorder, skip, limit, s, addHasAugmentations);

        // TODO: test validations
    }
    
    /**
     * Update Image Target
     *
     * Updates properties of a particular Target in your account. Currently following properties are supported: physicalHeight, metadata. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateImageTargetTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        String targetId = null;
        UpdateImageTargetBody updateImageTargetBody = null;
        ImageTargetResponse response = api.updateImageTarget(xVersion, xToken, contentType, tcId, targetId, updateImageTargetBody);

        // TODO: test validations
    }
    
}
