/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.CloudArchiveGenerationResponse;
import org.openapitools.client.model.CreateImageTargetCollectionBody;
import org.openapitools.client.model.GenerateWTCBody;
import org.openapitools.client.model.GenerateWTCStatusResponse;
import org.openapitools.client.model.ImageTargetCollectionResponse;
import org.openapitools.client.model.SimilarityCheckBody;
import org.openapitools.client.model.SimilarityCheckResponse;
import org.openapitools.client.model.SimilarityCheckStatusResponse;
import org.openapitools.client.model.UpdateImageTargetCollectionBody;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ImageTargetCollectionApi
 */
@Ignore
public class ImageTargetCollectionApiTest {

    private final ImageTargetCollectionApi api = new ImageTargetCollectionApi();

    
    /**
     * Create Image Target Collection
     *
     * Create a new target collection in your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createImageTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        CreateImageTargetCollectionBody createImageTargetCollectionBody = null;
        ImageTargetCollectionResponse response = api.createImageTargetCollection(xVersion, xToken, contentType, createImageTargetCollectionBody);

        // TODO: test validations
    }
    
    /**
     * Delete Image Target Collection
     *
     * Delete a particular target collection from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteImageTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        api.deleteImageTargetCollection(xVersion, xToken, tcId);

        // TODO: test validations
    }
    
    /**
     * Generate Cloud Archive
     *
     * DEPRECATED - Generate a Cloud Archive from an existing Target Collection. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate Cloud Archive). As of release 4.0.0 this endpoint will return error TARGET_COLLECTION_IS_UP_TO_DATE with status code 412, since the archive will be generated automatically in the background in the future. This endpoint is marked as \&quot;deprecated\&quot; since the behaviour will slightly change. However, this endpoint will still exist in version 3. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void generateCloudArchiveTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        CloudArchiveGenerationResponse response = api.generateCloudArchive(xVersion, xToken, tcId);

        // TODO: test validations
    }
    
    /**
     * Generate WTC
     *
     * Generates a WTC file out of an existing Target Collection with up to 1000 targets. The call is asynchronous and contains a path in the response header (Location) from which the status of the generation can be requested (see Status - Generate WTC). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void generateWTCTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        GenerateWTCBody generateWTCBody = null;
        GenerateWTCStatusResponse response = api.generateWTC(xVersion, xToken, contentType, tcId, generateWTCBody);

        // TODO: test validations
    }
    
    /**
     * Status - Generate Cloud Archive
     *
     * Retrieves information status about a particular scheduled cloud archive generation.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getCloudArchiveStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String generationId = null;
        CloudArchiveGenerationResponse response = api.getCloudArchiveStatus(xVersion, xToken, tcId, generationId);

        // TODO: test validations
    }
    
    /**
     * Get Image Target Collection
     *
     * Request a particular target collection from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImageTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        ImageTargetCollectionResponse response = api.getImageTargetCollection(xVersion, xToken, tcId);

        // TODO: test validations
    }
    
    /**
     * Get all Image Target Collections
     *
     * Request all target collections from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getImageTargetCollectionsTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        Integer skip = null;
        Integer limit = null;
        List<ImageTargetCollectionResponse> response = api.getImageTargetCollections(xVersion, xToken, skip, limit);

        // TODO: test validations
    }
    
    /**
     * Status - Similarity Check
     *
     * Retrieves information status of a particular scheduled \&quot;Similarity Check\&quot;.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSimilarityCheckStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String generationId = null;
        SimilarityCheckStatusResponse response = api.getSimilarityCheckStatus(xVersion, xToken, tcId, generationId);

        // TODO: test validations
    }
    
    /**
     * Status - Generate WTC
     *
     * Retrieves information status about a particular scheduled WTC file generation. Once the status is completed, the WTC information can be retrieved from the Target Collection (see Get Target Collection). 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getWTCStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String generationId = null;
        GenerateWTCStatusResponse response = api.getWTCStatus(xVersion, xToken, tcId, generationId);

        // TODO: test validations
    }
    
    /**
     * Similarity Check
     *
     * Pass up to 10 items pointing to PNG or JPEG images hosted via https in the body. In order to find out whether an image is similar to an existing Target in terms of recognition and tracking behaviour a check is performed per passed image item. The Target Collection must be published and have an active Cloud Archive in place. Up to 5 (default: 1) so called \&quot;candidates\&quot; with a similarity \&quot;score\&quot; are returned per image. Image must be hosted via https and be of type PNG or JPEG. Use \&quot;maxCandidates\&quot; to define the maximum amount of candidates to return for an image. Response header value \&quot;Location\&quot; directly points to the right \&quot;Status - Similarity Check\&quot; endpoint. Best practice is to trigger \&quot;Similarity Check\&quot;, wait for \&quot;estimatedLatency\&quot; milliseconds and poll \&quot;Status - Similarity Check\&quot; endpoint every 5 seconds until its \&quot;status\&quot; is \&quot;COMPLETED\&quot;. 
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void similarityCheckTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        SimilarityCheckBody similarityCheckBody = null;
        SimilarityCheckResponse response = api.similarityCheck(xVersion, xToken, contentType, tcId, similarityCheckBody);

        // TODO: test validations
    }
    
    /**
     * Update Image Target Collection
     *
     * Update a target collection from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateImageTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        UpdateImageTargetCollectionBody updateImageTargetCollectionBody = null;
        ImageTargetCollectionResponse response = api.updateImageTargetCollection(xVersion, xToken, contentType, tcId, updateImageTargetCollectionBody);

        // TODO: test validations
    }
    
}
