/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.CreateObjectTargetImagesBody;
import org.openapitools.client.model.CreateObjectTargetWTOBody;
import org.openapitools.client.model.ExtendObjectTargetBody;
import org.openapitools.client.model.ObjectTargetJobResponse;
import org.openapitools.client.model.ObjectTargetResponse;
import org.openapitools.client.model.RenameObjectTargetBody;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ObjectTargetApi
 */
@Ignore
public class ObjectTargetApiTest {

    private final ObjectTargetApi api = new ObjectTargetApi();

    
    /**
     * Create Object Target from Images
     *
     * Create a new Object Target in an Object Target Collection from at least two Image files.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createObjectTargetFromImagesTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        CreateObjectTargetImagesBody createObjectTargetImagesBody = null;
        ObjectTargetJobResponse response = api.createObjectTargetFromImages(xVersion, xToken, contentType, tcId, createObjectTargetImagesBody);

        // TODO: test validations
    }
    
    /**
     * Create Object Target from WTO
     *
     * Create a new Object Target in an Object Target Collection from a WTO file.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createObjectTargetFromWTOTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        CreateObjectTargetWTOBody createObjectTargetWTOBody = null;
        ObjectTargetJobResponse response = api.createObjectTargetFromWTO(xVersion, xToken, contentType, tcId, createObjectTargetWTOBody);

        // TODO: test validations
    }
    
    /**
     * Delete Object Target
     *
     * Delete a particular Object Target from your Object Target Collection.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteObjectTargetTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String targetId = null;
        api.deleteObjectTarget(xVersion, xToken, tcId, targetId);

        // TODO: test validations
    }
    
    /**
     * Extend Object Target
     *
     * Add source images to an existing target.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void extendObjectTargetTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        String targetId = null;
        ExtendObjectTargetBody extendObjectTargetBody = null;
        ObjectTargetJobResponse response = api.extendObjectTarget(xVersion, xToken, contentType, tcId, targetId, extendObjectTargetBody);

        // TODO: test validations
    }
    
    /**
     * Get Object Target
     *
     * Request a specific Object Targets from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getObjectTargetTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String targetId = null;
        ObjectTargetResponse response = api.getObjectTarget(xVersion, xToken, tcId, targetId);

        // TODO: test validations
    }
    
    /**
     * Status - Object Target Generation Information
     *
     * Retrieves information status about a particular scheduled Object Target creation.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getObjectTargetStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String generationId = null;
        ObjectTargetJobResponse response = api.getObjectTargetStatus(xVersion, xToken, tcId, generationId);

        // TODO: test validations
    }
    
    /**
     * Get Object Targets
     *
     * Request all Object Targets in a Target Collection.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getObjectTargetsTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        List<ObjectTargetResponse> response = api.getObjectTargets(xVersion, xToken, tcId);

        // TODO: test validations
    }
    
    /**
     * Rename Object Target
     *
     * Rename an existing target.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void renameObjectTargetTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        String targetId = null;
        RenameObjectTargetBody renameObjectTargetBody = null;
        ObjectTargetJobResponse response = api.renameObjectTarget(xVersion, xToken, contentType, tcId, targetId, renameObjectTargetBody);

        // TODO: test validations
    }
    
}
