/*
 * Wikitude Studio API
 * The Wikitude Studio API is a RESTful API which is used to * organize and manipulate projects and its targets * create wtc/wto files which can be used to create trackers in the Wikitude SDK with the JavaScript API * generate/publish a cloud archive to the cloud recognition service (image targets only)  Download API clients: * [`OpenAPI 3.0`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-openapi.zip) * [`JavaScript`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-javascript.zip) * [`Python`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-python.zip) * [`PHP`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-php.zip) * [`TypeScript (NodeJS)`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-typescript-node.zip) * [`Java`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-java.zip) * [`Ruby`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-ruby.zip) * [`C# .NET Core`](https://www.wikitude.com/external/doc/documentation/studio-api/clients/wikitude_studio_api_client-csharp-netcore.zip)  This technical reference formally explains various API endpoints. Visit the [`Studio API documentation`](https://www.wikitude.com/external/doc/documentation/studio/) for a more general description. 
 *
 * The version of the OpenAPI document: 3.0.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.api;

import org.openapitools.client.ApiException;
import org.openapitools.client.model.CreateObjectTargetCollectionBody;
import org.openapitools.client.model.GenerateWTOBody;
import org.openapitools.client.model.ObjectTargetCollectionJobResponse;
import org.openapitools.client.model.ObjectTargetCollectionResponse;
import org.openapitools.client.model.ObjectTargetJobResponse;
import org.openapitools.client.model.UpdateObjectTargetCollectionBody;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ObjectTargetCollectionApi
 */
@Ignore
public class ObjectTargetCollectionApiTest {

    private final ObjectTargetCollectionApi api = new ObjectTargetCollectionApi();

    
    /**
     * Create Object Target Collection
     *
     * Create a new Object Target Collection in your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void createObjectTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        CreateObjectTargetCollectionBody createObjectTargetCollectionBody = null;
        ObjectTargetCollectionResponse response = api.createObjectTargetCollection(xVersion, xToken, contentType, createObjectTargetCollectionBody);

        // TODO: test validations
    }
    
    /**
     * Delete Object Target Collection
     *
     * Delete a Object Target Collection and all its Object Targets.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void deleteObjectTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        api.deleteObjectTargetCollection(xVersion, xToken, tcId);

        // TODO: test validations
    }
    
    /**
     * Generate WTO
     *
     * Generate a WTO file containing the Object Target Collection and all its Object Targets.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void generateWTOTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        GenerateWTOBody generateWTOBody = null;
        ObjectTargetCollectionJobResponse response = api.generateWTO(xVersion, xToken, contentType, tcId, generateWTOBody);

        // TODO: test validations
    }
    
    /**
     * Get Object Target Collection
     *
     * Request a particular Object Target Collection from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getObjectTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        ObjectTargetCollectionResponse response = api.getObjectTargetCollection(xVersion, xToken, tcId);

        // TODO: test validations
    }
    
    /**
     * Status - Get Object Target Collection jobs
     *
     * Retrieves a list of asynchronous jobs sorted by creation date.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getObjectTargetCollectionStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        Integer skip = null;
        Integer limit = null;
        String source = null;
        String type = null;
        List<ObjectTargetJobResponse> response = api.getObjectTargetCollectionStatus(xVersion, xToken, tcId, skip, limit, source, type);

        // TODO: test validations
    }
    
    /**
     * Get all Object Target Collections
     *
     * Request all Object Target Collections from your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getObjectTargetCollectionsTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        Integer skip = null;
        Integer limit = null;
        List<ObjectTargetCollectionResponse> response = api.getObjectTargetCollections(xVersion, xToken, skip, limit);

        // TODO: test validations
    }
    
    /**
     * Status - Generate WTO
     *
     * Retrieves information status about a particular scheduled wto generation.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getWTOStatusTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String tcId = null;
        String generationId = null;
        ObjectTargetCollectionJobResponse response = api.getWTOStatus(xVersion, xToken, tcId, generationId);

        // TODO: test validations
    }
    
    /**
     * Update Object Target Collection
     *
     * Updates an existing Object Target Collection in your account.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateObjectTargetCollectionTest() throws ApiException {
        String xVersion = null;
        String xToken = null;
        String contentType = null;
        String tcId = null;
        UpdateObjectTargetCollectionBody updateObjectTargetCollectionBody = null;
        ObjectTargetCollectionResponse response = api.updateObjectTargetCollection(xVersion, xToken, contentType, tcId, updateObjectTargetCollectionBody);

        // TODO: test validations
    }
    
}
